package net.minecraft.src;

import java.io.File;
import java.util.ArrayList;

import org.lwjgl.opengl.GL11;

import net.minecraft.client.Minecraft;

public class BuildingSchematic {
	int xSize, ySize, zSize;
	byte[] blocks, meta;
	public BuildingSchematic(byte[] blocks, byte[] meta, int sizeX, int sizeY, int sizeZ){
		this.blocks = blocks;
		this.meta = meta;
		xSize = sizeX;
		ySize = sizeY;
		zSize = sizeZ;
	}
	
	
	private static void load(){
		File f = new File(mc.getMinecraftDir(), "Buildings");
		if(!f.exists()){
			f.mkdir();
		}
		ArrayList<File> schematics = getValidSchematics(f);
	}
	
	
	public static ArrayList<File> getValidSchematics(File f){
		ArrayList<File> toReturn = new ArrayList<File>();
		File[] files = f.listFiles();
		for(int a = 0; a < files.length; a++){
			if(files[a] != null && files[a].exists()){
				if(files[a].isDirectory()){
					ArrayList<File> f2 = getValidSchematics(files[a]);
					for(int b = 0; b < f2.size(); b++){
						toReturn.add(f2.get(b));
					}
				}else if(files[a].getName().toLowerCase().endsWith(".schematic")){
					toReturn.add(files[a]);
				}
			}
		}
		return toReturn;
	}
	
	static Minecraft mc;
	static ArrayList<BuildingSchematic> buildings = new ArrayList<BuildingSchematic>();
	
	static{
		mc = ModLoader.getMinecraftInstance();
		load();
	}
	
	public void render(int posX, int posY, int posZ){
		GL11.glPushMatrix();
		GL11.glDisable(GL11.GL_LIGHTING);
		for(int y = 0; y < ySize; y++){
			for(int z = 0; z < zSize; z++){
				for(int x = 0;  x < xSize; x++){
					int pos = ((x) + (y*(zSize*xSize)) +(z*xSize));
					int block = blocks[pos];
					int meta = this.meta[pos];
					MyRenderHelper.instance.renderBlock(Block.blocksList[block], meta, x+posX, y+posY, z+posZ);
				}
			}
		}
		GL11.glEnable(GL11.GL_LIGHTING);
		GL11.glPopMatrix();
	}

}
