package net.minecraft.src;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map.Entry;
import java.util.Random;

import net.minecraft.client.Minecraft;
import net.minecraft.src.mod_MyPeople.Team;

public class EntityMyPerson extends EntityPlayer {
	static int id = 0;
	int myID = 0;
	public Entity currentTarget;
	public Entity entityToAttack;
	int foodCoolDown = 0, checkPlayerTimer = 0, checkMobTimer = 0;

	static PlayerChat chat;
	
	double[] guardPositions = new double[4];

	private boolean hasAttacked = true;

	boolean justLoaded = true;

	float lastScaleCheck = 1.0f;

	float maxScale = 1.0f;

	public PathEntity pathToEntity;

	public String name = "";

	Random r = new Random();

	float scale = 1.0f;

	public PersonOptions options;

	boolean respawn = false;

	int spawnX, spawnY, spawnZ;

	long livingTime = 0;

	boolean eatCake = true;

	int[] cakeToEat = null;

	public boolean isMining = false;//, isFemale = false;

	int[] blockToPlace = null;

	ItemStack toUse = null;

	int[] blockToBreak = null;

	Entity entityToMount = null;

	private int curBlockX;

	private int curBlockY;

	private int curBlockZ;

	private float curBlockDamage;

	private float prevBlockDamage;

	private float blockDestroySoundCounter;

	private int blockHitWait;

	ArrayList<String> mobNames = null;

	ArrayList<Class> mobClasses = null;
	
	public mod_MyPeople.Team team = mod_MyPeople.Team.Good;
	
	public EntityMyPerson(World world) {
		super(world);
		ignoreFrustumCheck = true;
		foodCoolDown = 0;
		scale = .5f;
		lastScaleCheck = .5f;
		maxScale = 1.0f;
		justLoaded = true;
		changeSkin("*/mob/char.png");
		options = new PersonOptions(this);
		dimension = world.worldProvider.worldType;
		myID = id;
		id++;
	}

	public void addToPlayerList() {
		if (!worldObj.playerEntities.contains(this)) {
			worldObj.playerEntities.add(this);
		}
	}

	protected void attackEntity(Entity entity, float f) {
		if (attackTime <= 0) {
			if (f >= 3d
					&& f < 12d
					&& inventory.hasItem(Item.arrow.shiftedIndex)
					&& inventory.hasItem(Item.bow.shiftedIndex)
					&& !(entity instanceof EntityEnderman || entity instanceof EntitySlime)) {
				changeToItemBow(ItemBow.class);
			} else if (f < 3d) {
				changeToItemWeapon(ItemSword.class);
			}
			if (f < (2.5d + rand.nextFloat())) {
				hasAttacked = true;
				swingItem();
				ItemStack item = getCurrentEquippedItem();
				attackTargetEntityWithCurrentItem(entity);
				scale += .00001f;
				attackTime = isTraitor() ? 12 : 5;
			} else if (f < 12
					&& inventory.getCurrentItem() != null
					&& inventory.getCurrentItem().itemID == Item.bow.shiftedIndex
					&& inventory.hasItem(Item.arrow.shiftedIndex)) {
				double d = entity.posX - posX;
				double d1 = entity.posZ - posZ;
				if (attackTime == 0) {
					EntityArrow entityarrow = new EntityArrow(worldObj, this,
							1.0f);
					double d2 = (entity.posY + entity.getEyeHeight())
							- 0.69999998807907104D - entityarrow.posY;
					float f1 = MathHelper.sqrt_double(d * d + d1 * d1) * 0.2F;
					worldObj.playSoundAtEntity(this, "random.bow", 1.0F,
							1.0F / (rand.nextFloat() * 0.4F + 0.8F));
					worldObj.spawnEntityInWorld(entityarrow);
					entityarrow.setArrowHeading(d, d2 + f1, d1, 1.6F,
							isTraitor() ? 12F : 0F);
					this.inventory
					.consumeInventoryItem(Item.arrow.shiftedIndex);
					attackTime = isTraitor() ? 30 : 20;
					scale += .00001f;
				}
				rotationYaw = (float) ((Math.atan2(d1, d) * 180D) / 3.1415927410125732D) - 90F;
				hasAttacked = true;
			}
		}
	}
	
	public boolean isTraitor(){
		return Team.Evil.equals(team);
	}

	@Override
	public boolean attackEntityFrom(DamageSource damagesource, int i) {
		if (options.fight && options.retaliate) {
			Entity e = damagesource.getEntity();
			if (e != null) {
				if ((!(e instanceof EntityPlayer) || isTraitor())) {
					boolean theyAreTraitor = false;
					if (e instanceof EntityMyPerson) {
						theyAreTraitor = ((EntityMyPerson) e).isTraitor();
					}
					if ((!(e instanceof EntityMyPerson) || isTraitor())
							|| theyAreTraitor) {
						currentTarget = e;
						entityToAttack = e;
						pathToEntity = getPathToEntity(entityToAttack, 24F);
						scale += i / 10000d;
					}
				}
			}
		}
		if (!DamageSource.inWall.getDamageType().equals(damagesource.getDamageType())) {
	        if (!((float)heartsLife > (float)heartsHalvesLife / 2.0F)){
	        	if(damagesource.getSourceOfDamage() != null && damagesource.getSourceOfDamage() instanceof EntityArrow){
					say("shot");
				}else{
					say("hurt");
				}
	        }
			return super.attackEntityFrom(damagesource, i);
		}


		return false;
	}

	@Override
	public void attackTargetEntityWithCurrentItem(Entity entity) {
		int i = inventory.getDamageVsEntity(entity);
		if (isPotionActive(Potion.damageBoost)) {
			i += 3 << getActivePotionEffect(Potion.damageBoost).getAmplifier();
		}
		if (isPotionActive(Potion.weakness)) {
			i -= 2 << getActivePotionEffect(Potion.weakness).getAmplifier();
		}
		int j = 0;
		int k = 0;
		if (entity instanceof EntityLiving) {
			k = EnchantmentHelper.getEnchantmentModifierLiving(inventory,
					(EntityLiving) entity);
			j += EnchantmentHelper.getKnockbackModifier(inventory,
					(EntityLiving) entity);
		}
		if (isSprinting()) {
			j++;
		}
		if (i > 0 || k > 0) {
			boolean flag = fallDistance > 0.0F && !onGround && !isOnLadder()
					&& !isInWater() && !isPotionActive(Potion.blindness)
					&& ridingEntity == null && (entity instanceof EntityLiving);
			if (flag) {
				i += rand.nextInt(i / 2 + 2);
			}
			i += k;
			boolean flag1 = entity.attackEntityFrom(
					DamageSource.causePlayerDamage(this),
					(int) Math.ceil(i
							* (isTraitor()? scale / .75f : scale)));
			if (flag1) {
				if (j > 0) {
					entity.addVelocity(
							-MathHelper.sin((rotationYaw * 3.141593F) / 180F)
							* j * 0.5F, 0.10000000000000001D,
							MathHelper.cos((rotationYaw * 3.141593F) / 180F)
							* j * 0.5F);
					motionX *= 0.59999999999999998D;
					motionZ *= 0.59999999999999998D;
					setSprinting(false);
				}
				Minecraft mc = ModLoader.getMinecraftInstance();
				if (flag) {
					mc.effectRenderer.addEffect(new EntityCrit2FX(worldObj,
							entity));
				}
				if (k > 0) {
					EntityCrit2FX entitycrit2fx = new EntityCrit2FX(
							mc.theWorld, entity, "magicCrit");
					mc.effectRenderer.addEffect(entitycrit2fx);
				}
				if (i >= 18) {
					triggerAchievement(AchievementList.overkill);
				}
			}
			ItemStack itemstack = getCurrentEquippedItem();
			if (itemstack != null && (entity instanceof EntityLiving)) {
				itemstack.hitEntity((EntityLiving) entity, this);
				if (itemstack.stackSize <= 0) {
					itemstack.onItemDestroyedByUse(this);
					destroyCurrentEquippedItem();
					say("break");
				}
			}
			if (entity instanceof EntityLiving) {
				if (entity.isEntityAlive()) {
					alertWolves((EntityLiving) entity, true);
				}
				addStat(StatList.damageDealtStat, i);
				int l = EnchantmentHelper.getFireAspectModifier(inventory,
						(EntityLiving) entity);
				if (l > 0) {
					entity.setFire(l * 4);
				}
			}
			addExhaustion(0.3F);
		}
	}

	@Override
	protected boolean canDespawn() {
		return false;
	}

	public BlockPositionEntry canSeeBlock(int x, int y, int z) {
		double d = this.getDistance(new int[] { x, y, z });
		if (d < 1) {
			new BlockPositionEntry(null, true);
		}
		BlockPositionEntry e = new BlockPositionEntry(null, false);

		MovingObjectPosition p1 = worldObj.rayTraceBlocks(Vec3D.createVector(
				posX, posY + getEyeHeight(), posZ + .5), Vec3D
				.createVector(x + .5, y, z + .5));
		if (p1 != null) {
			e.m = p1;
		} else {
			e.canSeeAtAll = true;
		}
		p1 = worldObj.rayTraceBlocks(
				Vec3D.createVector(posX, posY + getEyeHeight(), posZ),
				Vec3D.createVector(x + .5, y + 1, z + .5));
		if (p1 != null) {
			e.m = p1;
		} else {
			e.canSeeAtAll = true;
		}
		p1 = worldObj.rayTraceBlocks(
				Vec3D.createVector(posX, posY + getEyeHeight(), posZ),
				Vec3D.createVector(x + .5, y + .5, z));
		if (p1 != null) {
			e.m = p1;
		} else {
			e.canSeeAtAll = true;
		}
		p1 = worldObj.rayTraceBlocks(
				Vec3D.createVector(posX, posY + getEyeHeight(), posZ),
				Vec3D.createVector(x + .5, y + .5, z + 1));
		if (p1 != null) {
			e.m = p1;
		} else {
			e.canSeeAtAll = true;
		}
		p1 = worldObj.rayTraceBlocks(
				Vec3D.createVector(posX, posY + getEyeHeight(), posZ),
				Vec3D.createVector(x, y + .5, z + .5));
		if (p1 != null) {
			e.m = p1;
		} else {
			e.canSeeAtAll = true;
		}
		p1 = worldObj.rayTraceBlocks(
				Vec3D.createVector(posX, posY + getEyeHeight(), posZ),
				Vec3D.createVector(x + 1, y + .5, z + .5));
		if (p1 != null) {
			e.m = p1;
		} else {
			e.canSeeAtAll = true;
		}
		return e;
	}

	public void changeSkin(String s) {
		if (s.startsWith("*")) {
			try {
				if (EntityMyPerson.class.getResource(s.substring(1)) != null) {
					username = s;
					s = s.substring(1);
					skinUrl = null;
					texture = s;
					String s2 = s
							.substring(
									(s.contains("/") ? s.lastIndexOf("/") + 1
											: 0),
											(s.contains(".") ? s.lastIndexOf(".") : s
													.length()));
					if (s2.length() > 1) {
						s2 = s2.substring(0, 1).toUpperCase() + s2.substring(1);
					}
					name = s2;
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else {
			username = s;
			skinUrl = (new StringBuilder())
					.append("http://s3.amazonaws.com/MinecraftSkins/")
					.append(username).append(".png").toString();
			name = s;
			worldObj.obtainEntitySkin(this);
		}

	}

	public boolean changeToItemBow(Class itemClass) {
		if (ItemBow.class.isAssignableFrom(itemClass)) {
			int bestId = -1;
			float goodness = 0;
			for (int a = 0; a < 9; a++) {
				ItemStack stack = inventory.mainInventory[a];
				if (stack != null
						&& itemClass.isAssignableFrom(stack.getItem()
								.getClass())) {
					ItemBow tool = (ItemBow) stack.getItem();
					float f = tool.getDamageVsEntity(entityToAttack);
					if (f > goodness) {
						goodness = f;
						bestId = a;
					}
				}
			}
			if (bestId > -1) {
				inventory.currentItem = bestId;
				return true;
			}
		}
		return false;
	}

	public boolean changeToItemTool(Class itemClass) {
		if (ItemTool.class.isAssignableFrom(itemClass)) {
			int bestId = -1;
			float goodness = 0;
			for (int a = 0; a < 9; a++) {
				ItemStack stack = inventory.mainInventory[a];
				if (stack != null
						&& itemClass.isAssignableFrom(stack.getItem()
								.getClass())) {
					ItemTool tool = (ItemTool) stack.getItem();
					float f = tool.efficiencyOnProperMaterial;
					if (f > goodness) {
						goodness = f;
						bestId = a;
					}
				}
			}
			if (bestId > -1) {
				inventory.currentItem = bestId;
				return true;
			}
		}
		return false;
	}

	public boolean changeToItemWeapon(Class itemClass) {
		if (ItemSword.class.isAssignableFrom(itemClass)) {
			int bestId = -1;
			float goodness = 0;
			for (int a = 0; a < 9; a++) {
				ItemStack stack = inventory.mainInventory[a];
				if (stack != null
						&& itemClass.isAssignableFrom(stack.getItem()
								.getClass())) {
					ItemSword tool = (ItemSword) stack.getItem();
					float f = tool.getDamageVsEntity(entityToAttack);
					if (f > goodness) {
						goodness = f;
						bestId = a;
					}
				}
			}
			if (bestId > -1) {
				inventory.currentItem = bestId;
				return true;
			}
		}
		return false;
	}

	public void checkArmor() {
		for (int a = 0; a < 4; a++) {
			ItemStack arm = inventory.armorInventory[a];
			ItemArmor currentBestArmor = (ItemArmor) (arm == null ? null : arm
					.getItem());
			int best = inventory.mainInventory.length + a;
			boolean changed = false;
			for (int b = 0; b < inventory.mainInventory.length; b++) {
				ItemStack stack2 = inventory.mainInventory[b];
				if (stack2 != null
						&& ItemArmor.class.isAssignableFrom(stack2.getItem()
								.getClass())) {
					ItemArmor arm1 = (ItemArmor) stack2.getItem();
					if (arm1.armorType == 3 - a) {
						if (isArmorBetter(arm1, currentBestArmor)) {
							changed = true;
							best = b;
							currentBestArmor = arm1;
						}
					}
				}
			}
			if (changed) {
				swapItems(a, best);
			}
		}
	}

	public void checkBlockValid() {
		if (blockToBreak != null) {
			int i = worldObj.getBlockId(blockToBreak[0], blockToBreak[1],
					blockToBreak[2]);
			if (i == 0
					|| !isSeeThru(canSeeBlock(blockToBreak[0], blockToBreak[1],
							blockToBreak[2]))) {
				blockToBreak = null;
				pathToEntity = null;
				stopMining();
			}
		}
	}

	private boolean checkPlayerAndRun() {
		if (options.follow) {
			EntityPlayer p = ModLoader.getMinecraftInstance().thePlayer;
			if (p != null) {
				double distance = getDistanceToEntity(p);
				if (this.ridingEntity == null) {
					if (distance > 25) {
						int i = MathHelper.floor_double(p.posX) - 2;
						int j = MathHelper.floor_double(p.posZ) - 2;
						int k = MathHelper.floor_double(p.boundingBox.minY);
						for (int l = 0; l <= 4; l++) {
							for (int i1 = 0; i1 <= 4; i1++) {
								if ((l < 1 || i1 < 1 || l > 3 || i1 > 3)
										&& worldObj.isBlockNormalCube(i + l,
												k - 1, j + i1)
												&& !worldObj.isBlockNormalCube(i + l,
														k, j + i1)
														&& !worldObj.isBlockNormalCube(i + l,
																k + 1, j + i1)) {
									setLocationAndAngles((i + l) + 0.5F, k,
											(j + i1) + 0.5F, rotationYaw,
											rotationPitch);
									return true;
								}
							}
						}
					} else if (distance > (options.fight ? 5d : 1.2d)) {
						pathToEntity = getPathToEntity(p,
								(float) Math.ceil(distance));
						return true;
					}
				} else {
					if (distance < 100) {
						pathToEntity = getPathToEntity(p,
								(float) Math.ceil(distance));
						return true;
					}
				}
			}
		} else if (options.guard && guardPositions[3]==(ModLoader.getMinecraftInstance().theWorld.getWorldInfo().getDimension())) {
			double distance = this.getDistance(guardPositions[0],
					guardPositions[1], guardPositions[2]);
			if (distance > 40) {
				this.setPosition(guardPositions[0], guardPositions[1],
						guardPositions[2]);
			} else if (distance > 1d) {
				pathToEntity = getEntityPathToXYZ(
						(int) Math.round(guardPositions[0]),
						(int) Math.round(guardPositions[1]),
						(int) Math.round(guardPositions[2]),
						(float) distance * 2f);
				return true;
			}
		}
		return false;
	}


	private void checkToPlantCrops(ItemStack stack) {
		ArrayList<Integer> toGet = new ArrayList<Integer>();
		toGet.add(Block.tilledField.blockID);
		ArrayList<int[]> poss = getBlocks(toGet);
		if (poss.size() > 0) {
			poss = sort(poss);
			for (int a = 0; a < poss.size(); a++) {
				int[] pos = poss.get(a);
				int id = worldObj.getBlockId(pos[0], pos[1] + 1, pos[2]);
				if (id == 0) {
					BlockPositionEntry e = this.canSeeBlock(pos[0], pos[1],
							pos[2]);
					if (e != null && (e.canSeeAtAll || e.m == null)) {
						placeBlock(pos, stack);
					}
				}
			}
		}

	}

	public void faceBlock(int[] pos, float f, float f1) {
		double d = pos[0] - posX + .5d;
		double d1 = pos[1] + .5 - (posY + getEyeHeight());
		double d2 = pos[2] - posZ + .5d;

		double d3 = MathHelper.sqrt_double(d * d + d2 * d2);
		float f2 = (float) ((Math.atan2(d2, d) * 180D) / 3.1415927410125732D) - 90F;
		float f3 = (float) (-((Math.atan2(d1, d3) * 180D) / 3.1415927410125732D));
		rotationPitch = updateRotation(rotationPitch, f3, f1);
		rotationYaw = updateRotation(rotationYaw, f2, f);
	}

	public boolean findAndBreakBlocks(ArrayList<Class> allBlocksToBreak) {
		int[] block = getAllBlocks(allBlocksToBreak);
		if (block != null) {
			blockToBreak = block;
			setPathToBlock(block);
			return true;
		}
		return false;

	}

	private Entity findEntityToAttack() {

			List get = new ArrayList();
			if (options.huntMob) {
				List get2 = worldObj.getEntitiesWithinAABB(
						net.minecraft.src.IMob.class,
						AxisAlignedBB.getBoundingBoxFromPool(posX, posY, posZ,
								posX + 1.0D, posY + 1.0D, posZ + 1.0D).expand(
										24D, 4D, 24D));
				for (int a = 0; a < get2.size(); a++) {
					get.add(get2.get(a));
				}
			}
			if (options.huntAnimal) {
				List get2 = worldObj.getEntitiesWithinAABB(
						net.minecraft.src.EntityAnimal.class,
						AxisAlignedBB.getBoundingBoxFromPool(posX, posY, posZ,
								posX + 1.0D, posY + 1.0D, posZ + 1.0D).expand(
										24D, 4D, 24D));
				for (int a = 0; a < get2.size(); a++) {
					get.add(get2.get(a));
				}
			}
			if(options.fight){
				List get2 = worldObj.getEntitiesWithinAABB(
						net.minecraft.src.EntityMyPerson.class,
						AxisAlignedBB.getBoundingBoxFromPool(posX, posY, posZ,
								posX + 1.0D, posY + 1.0D, posZ + 1.0D).expand(
										24D, 4D, 24D));
				for (int a = 0; a < get2.size(); a++) {
					EntityMyPerson other = ((EntityMyPerson) get2.get(a));
					if( canAttackEachother(other)) {
						get.add(get2.get(a));
					}
				}
			}

			if (isTraitor() && options.fight) {
				List get2 = worldObj.getEntitiesWithinAABB(
						net.minecraft.src.EntityPlayerSP.class,
						AxisAlignedBB.getBoundingBoxFromPool(posX, posY, posZ,
								posX + 1.0D, posY + 1.0D, posZ + 1.0D).expand(
										24D, 4D, 24D));
				for (int a = 0; a < get2.size(); a++) {
					if (!get2.get(a).equals(this)) {
						get.add(get2.get(a));
					}
				}
			}
			int index = 0;
			double distanceSq = -1;
			if (get.size() > 0) {
				for (int a = 0; a < get.size(); a++) {
					double d = this.getDistanceSqToEntity((Entity) get.get(a));
					if ((d < distanceSq || distanceSq == -1)
							&& canEntityBeSeen((Entity) get.get(a))
							&& ((Entity) get.get(a)).isEntityAlive()) {
						distanceSq = d;
						if (distanceSq < 0) {
							distanceSq *= -1;
						}
						index = a;
					}
				}
				if (distanceSq != -1) {
					return (Entity) get.get(index);
				}
			}
		return null;
	}

	public boolean findXPOrItemstacksAndSetCourse() {
		if (options.pickUp) {
			List entities = worldObj.getEntitiesWithinAABB(
					net.minecraft.src.EntityXPOrb.class,
					AxisAlignedBB.getBoundingBoxFromPool(posX, posY, posZ,
							posX + 1.0D, posY + 1.0D, posZ + 1.0D).expand(16D,
									4D, 16D));
			List entities2 = worldObj.getEntitiesWithinAABB(
					net.minecraft.src.EntityItem.class,
					AxisAlignedBB.getBoundingBoxFromPool(posX, posY, posZ,
							posX + 1.0D, posY + 1.0D, posZ + 1.0D).expand(16D,
									4D, 16D));
			for (int a = 0; a < entities2.size(); a++) {
				entities.add(entities2.get(a));
			}
			int index = 0;
			double distanceSq = -1;
			if (entities.size() > 0) {
				for (int a = 0; a < entities.size(); a++) {
					double d = this.getDistanceSqToEntity((Entity) entities
							.get(a));
					if ((d < distanceSq || distanceSq == -1)
							&& canEntityBeSeen((Entity) entities.get(a))) {
						distanceSq = d;
						if (distanceSq < 0) {
							distanceSq *= -1;
						}
						index = a;
					}
				}
				if (distanceSq != -1) {
					pathToEntity = getPathToEntity(
							(Entity) entities.get(index), 20F);
					return true;
				}
			}
		}
		return false;
	}
	@Override
	public void func_6420_o() {
	}

	public int[] getAllBlocks(ArrayList<Class> blockToBreak) {
		ArrayList<int[]> positions = getBlocksByClass(blockToBreak);
		BlockPositionEntry p = null;
		if (positions.size() > 0) {
			positions = sort(positions);
			for (int a = 0; a < positions.size(); a++) {
				int[] pos = positions.get(a);
				int id = worldObj.getBlockId(pos[0], pos[1], pos[2]);
				p = canSeeBlock(pos[0], pos[1], pos[2]);
				if(preBlockDestroy(Block.blocksList[id].getClass(), pos)){
					if (p.m == null
							|| p.canSeeAtAll
							|| isValidBlock(worldObj.getBlockId(p.m.blockX,
									p.m.blockY, p.m.blockZ))) {
						boolean OK = switchTool(id);
						if (!OK) {
							return null;
						}
						return pos;
					} else if (p != null && options.breakExtraBlocks) {
						int[] positions2 = { p.m.blockX, p.m.blockY, p.m.blockZ };
						int blockID = worldObj.getBlockId(positions2[0],
								positions2[1], positions2[2]);
						if (p.canSeeAtAll || isSeeThrough(blockID)
								&& switchTool(blockID)) {
							return positions2;
						}
					}
				}
			}
		}
		return null;
	}

	public float getBlockPathWeight(int i, int j, int k) {
		if (worldObj.getBlockId(i, j - 1, k) == Block.grass.blockID) {
			return 10F;
		} else {
			return worldObj.getLightBrightness(i, j, k) - 0.5F;
		}
	}

	public ArrayList<int[]> getBlocks(ArrayList<Integer> blockTypes) {
		ArrayList<int[]> ret = new ArrayList<int[]>();
		int startX = (int) Math.floor(posX - 10);
		int startY = (int) Math.floor(posY - 5);
		int startZ = (int) Math.floor(posZ - 10);
		int stopX = (int) Math.floor(posX + 10);
		int stopY = (int) Math.floor(posY + 5);
		int stopZ = (int) Math.floor(posZ + 10);
		for (int a = startX; a < stopX; a++) {
			for (int b = startY; b < stopY; b++) {
				for (int c = startZ; c < stopZ; c++) {
					if (b > 0) {
						int id = worldObj.getBlockId(a, b, c);
						if (blockTypes.contains(id)) {
							ret.add(new int[] { a, b, c });
						}
					}
				}
			}
		}
		return ret;
	}

	public ArrayList<int[]> getBlocksByClass(ArrayList<Class> blockTypes) {
		ArrayList<int[]> ret = new ArrayList<int[]>();
		int startX = (int) Math.floor(posX - 10);
		int startY = (int) Math.floor(posY - 5);
		int startZ = (int) Math.floor(posZ - 10);
		int stopX = (int) Math.floor(posX + 10);
		int stopY = (int) Math.floor(posY + 5);
		int stopZ = (int) Math.floor(posZ + 10);
		for (int a = startX; a < stopX; a++) {
			for (int b = startY; b < stopY; b++) {
				for (int c = startZ; c < stopZ; c++) {
					if (b > 0) {
						int id = worldObj.getBlockId(a, b, c);
						if (id > 0 && id < 256) {
							Block block = Block.blocksList[id];
							if (block != null) {
								for (int d = 0; d < blockTypes.size(); d++) {
									Class cl = blockTypes.get(d);
									if (cl.isAssignableFrom(block.getClass())) {
										ret.add(new int[] { a, b, c });
									}
								}
							}
						}
					}
				}
			}
		}
		return ret;
	}

	public int getClosest(ArrayList<int[]> blocks) {
		int closest = -1;
		double lDistance = 0;
		for (int a = 0; a < blocks.size(); a++) {
			int[] pos = blocks.get(a);
			if (pos.length == 3) {
				double distance = getDistance(pos);
				if (distance < lDistance || lDistance == 0) {
					lDistance = distance;
					closest = a;
				}
			}
		}

		return closest;
	}

	private int getClosestUnmountedEntityFromList(List entities) {
		double distance = -1;
		int pos = -1;
		for (int a = 0; a < entities.size(); a++) {
			Entity e = (Entity) entities.get(a);
			if (e.riddenByEntity == null) {
				double d = e.getDistanceSqToEntity(this);
				if (distance == -1d || d < distance) {
					distance = d;
					pos = a;
				}
			}
		}
		return pos;
	}

	@Override
	protected String getDeathSound() {
		Class c = getSoundClass();
		if (c != null) {
			if (EntityLiving.class.isAssignableFrom(c)) {
				try {
					EntityLiving living = (EntityLiving) c.getConstructor(
							new Class[] { net.minecraft.src.World.class })
							.newInstance(new Object[] { worldObj });
					if (living != null) {
						return living.getDeathSound();
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
		return "damage.hurtflesh";
	}

	public double getDistance(int[] pos) {
		double dx = pos[0] - posX;
		double dy = pos[1] - posY;
		double dz = pos[2] - posZ;
		return dx * dx + dy * dy + dz * dz;
	}

	private ArrayList<Class> getEntityClasses() {
		loadNamesAndClasses();
		return mobClasses;
	}
	private ArrayList<String> getEntityNames() {
		loadNamesAndClasses();
		return mobNames;
	}

	public PathEntity getEntityPathToXYZ(int x, int y, int z, float f) {
		return worldObj.getEntityPathToXYZ(this, x, y, z, f, true, false,
				false, true);
	}

	public String getEntityTexture() {
		return texture;
	}

	@Override
	public float getEyeHeight() {
		return super.getEyeHeight() * (scale > 1.0f ? 1.0f : scale);
	}

	@Override
	protected String getHurtSound() {
		Class c = getSoundClass();
		if (c != null) {
			if (EntityLiving.class.isAssignableFrom(c)) {
				try {
					EntityLiving living = (EntityLiving) c.getConstructor(
							new Class[] { net.minecraft.src.World.class })
							.newInstance(new Object[] { worldObj });
					if (living != null) {
						return living.getHurtSound();
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
		return "damage.hurtflesh";
	}

	@Override
	protected String getLivingSound() {
		Class c = getSoundClass();
		if (c != null) {
			if (EntityLiving.class.isAssignableFrom(c)) {
				try {
					EntityLiving living = (EntityLiving) c.getConstructor(
							new Class[] { net.minecraft.src.World.class })
							.newInstance(new Object[] { worldObj });
					if (living != null) {
						return living.getLivingSound();
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
		return null;
	}

	@Override
	public int getMaxHealth() {
		return 10 + (int) Math.round((scale + .5) * 20);
	}

	public PathEntity getPathToEntity(Entity e, float f) {
		return worldObj.getPathEntityToEntity(this, e, f, true, false, false,
				true);
	}

	public ChunkCoordinates getPlacedPosition() {
		return new ChunkCoordinates(spawnX, spawnY, spawnZ);
	}

	public int getPotionId(ItemFood food) {
		Field f = null;
		try {
			f = ItemFood.class.getDeclaredField("bX");
		} catch (Exception e) {
			try {
				f = ItemFood.class.getDeclaredField("potionId");
			} catch (Exception e2) {
				e2.printStackTrace();
			}
		}
		if (f != null) {
			try {
				f.setAccessible(true);
				Object o = f.get(food);
				if (o != null) {
					return (Integer) o;
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return -1;
	}

	private Class getSoundClass() {
		ArrayList<String> mobNames = getEntityNames();
		ArrayList<Class> mobClasses = getEntityClasses();
		for (int a = 0; a < mobNames.size(); a++) {
			if (name.toLowerCase().equals(mobNames.get(a).toLowerCase())) {
				return mobClasses.get(a);
			}
		}
		return null;
	}

	public int[][] getSurroundingPositions(int[] pos) {
		int[][] poss = null;
		if (pos != null && pos.length == 3) {
			poss = new int[6][3];
			poss[0][0] = pos[0] + 1;
			poss[0][1] = pos[1];
			poss[0][2] = pos[2];

			poss[1][0] = pos[0];
			poss[1][1] = pos[1];
			poss[1][2] = pos[2] + 1;

			poss[2][0] = pos[0] - 1;
			poss[2][1] = pos[1];
			poss[2][2] = pos[2];

			poss[3][0] = pos[0];
			poss[3][1] = pos[1];
			poss[3][2] = pos[2] - 1;

			poss[4][0] = pos[0];
			poss[4][1] = pos[1] + 1;
			poss[4][2] = pos[2];

			poss[5][0] = pos[0];
			poss[5][1] = pos[1] - 1;
			poss[5][2] = pos[2];
		}
		return poss;
	}

	public int getSwordGoodness(int id) {
		try {
			Item item = Item.itemsList[id];
			if (item != null
					&& ItemSword.class.isAssignableFrom(item.getClass())) {
				ItemSword itemSword = (ItemSword) item;
				EnumToolMaterial material = getToolMaterial(itemSword);
				if (material != null) {
					return (Math
							.round(material.getEfficiencyOnProperMaterial() * 1000));
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return -1;
	}

	private EnumToolMaterial getToolMaterial(ItemSword itemSword) {
		try {
			Field[] fields = ItemSword.class.getDeclaredFields();
			for (int a = 0; a < fields.length; a++) {
				fields[a].setAccessible(true);
				try {
					Object o = fields[a].get(itemSword);
					if (o instanceof EnumToolMaterial) {
						return (EnumToolMaterial) o;
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	@Override
	public double getYOffset() {
		return super.getYOffset();// *(scale)+.2;
	}

	public ItemStack hasItem(Item item) {
		for (int a = 0; a < 9; a++) {
			ItemStack stack = inventory.mainInventory[a];
			if (stack != null && stack.getItem().equals(item)) {
				return stack;
			}
		}
		return null;
	}

	public boolean hasPath() {
		return pathToEntity != null;
	}

	@Override
	public boolean interact(EntityPlayer entityplayer) {
		if (entityplayer.ridingEntity == this) {
			entityplayer.mountEntity(null);
		} else if(!mod_MyPeople.instance.isMounting){
			ModLoader.getMinecraftInstance().displayGuiScreen(
					new GuiTransferPlayerItems(this, entityplayer, false));
		}
		return false;
	}

	public boolean isArmorBetter(ItemArmor arm1, ItemArmor arm2) {
		return arm2 == null ? true : (arm1 == null ? false
				: arm1.damageReduceAmount > arm2.damageReduceAmount);
	}

	public boolean isBlock(Class blockClass, int id) {
		return isBlock(new Class[] { blockClass }, id);
	}

	public boolean isBlock(Class[] blockClass, int id) {
		if (id > 0 && id < 256) {
			Block b = Block.blocksList[id];
			if (b != null) {
				for (int a = 0; a < blockClass.length; a++) {
					if (blockClass[a] != null
							&& blockClass[a].isAssignableFrom(b.getClass())) {
						return true;
					}
				}
			}
		}
		return false;
	}

	public boolean isBad(ItemStack a) {
		int i1 = getPotionId((ItemFood) a.getItem());
		if (i1 == Potion.hunger.id || i1 == Potion.poison.id || i1 == Potion.weakness.id) {
			return true;
		} else {
			return false;
		}
	}

	@Override
	public boolean isInRangeToRenderVec3D(Vec3D par1Vec3D) {
		return true;
	}

	public boolean isMapRight(Class c1, Class c2, HashMap map) {
		for (Iterator<Entry> i = map.entrySet().iterator(); i.hasNext();) {
			Entry entry = i.next();
			Class cs1 = entry.getKey().getClass();
			Class cs2 = entry.getValue().getClass();
			if (cs1 == c1 && c2 == cs2) {
				return true;
			}
		}

		return false;
	}

	public boolean isMaterial(Material[] ms, Material m2) {
		for (int a = 0; a < ms.length; a++) {
			Material m = ms[a];
			if (m.equals(m2)) {
				return true;
			}
		}

		return false;
	}

	@Override
	public boolean isPlayerFullyAsleep() {
		return true;
	}

	@Override
	public boolean isPlayerSleeping() {
		if (ModLoader.getMinecraftInstance().thePlayer.isPlayerSleeping()) {
			playerLocation = ModLoader.getMinecraftInstance().thePlayer.playerLocation;
			return true;
		}
		return false;
	}

	private boolean isSeeThrough(int blockID) {
		if (blockID > 0 && blockID < 256) {
			Block b = Block.blocksList[blockID];
			Material m = b.blockMaterial;
			if (m.equals(Material.glass)
					|| m.equals(Material.leaves)) {
				return true;
			}
		}
		return false;
	}

	private boolean isSeeThru(BlockPositionEntry o) {
		if (o == null || o.m == null || o.canSeeAtAll) {
			return true;
		}
		if (blockToBreak[0] == o.m.blockX && blockToBreak[1] == o.m.blockY
				&& blockToBreak[2] == o.m.blockZ) {
			return true;
		}
		int id = worldObj.getBlockId(o.m.blockX, o.m.blockY, o.m.blockZ);
		if (id > 0 && id < 256) {
			Block b = Block.blocksList[id];
			Material m = b.blockMaterial;
			if (!b.isOpaqueCube() || m.equals(Material.glass)
					|| m.equals(Material.leaves)) {
				return true;
			}
		}
		return false;
	}

	public boolean isSword(int i) {
		try {
			Item item = Item.itemsList[i];
			if (item != null) {
				if (ItemSword.class.isAssignableFrom(item.getClass())) {
					return true;
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}

	private boolean isValidBlock(int blockId) {
		return (isBlock(BlockLog.class, blockId) && options.lumber)
				|| (isBlock(BlockOre.class, blockId) && options.mine);
	}

	public void loadNamesAndClasses() {
		if (mobNames == null || mobClasses == null) {
			Field[] fields = EntityList.class.getDeclaredFields();
			try {
				for (int a = 0; a < fields.length; a++) {
					fields[a].setAccessible(true);
					try {
						Object o = fields[a].get(null);
						if (o instanceof HashMap) {
							HashMap map = null;
							if (isMapRight(java.lang.String.class,
									java.lang.Class.class, map = (HashMap) o)) {
								mobNames = new ArrayList<String>();
								mobClasses = new ArrayList<Class>();
								for (Iterator<Entry<String, Class>> it = map
										.entrySet().iterator(); it.hasNext();) {
									Entry<String, Class> entry = it.next();
									mobNames.add(entry.getKey());
									mobClasses.add(entry.getValue());
								}
							}
						}
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	@Override
	public void onDeath(DamageSource damagesource) {
		if (inventory.hasItem(Item.appleGold.shiftedIndex)) {
			respawn = true;
		}
		if (!respawn) {
			removeFromPlayerList();
			if (mod_MyPeople.entityToFind != null
					&& mod_MyPeople.entityToFind.equals(this)) {
				mod_MyPeople.entityToFind = null;
			}
		}

		if (!respawn) {
			say("die");
			super.onDeath(damagesource);
		}
	}

	@Override
	public void onEntityDeath() {
		if (respawn) {
			if (inventory.consumeInventoryItem(Item.appleGold.shiftedIndex)) {
				inventory.dropAllItems();
				GuiChooserPlayerToFind.throwParticles(this, new Random(),
						worldObj);
				ChunkCoordinates chunkcoordinates = null;
				ChunkCoordinates chunkcoordinates1 = null;
				boolean flag = true;
				if (chunkcoordinates1 == null) {
					chunkcoordinates1 = getPlacedPosition();
					flag = false;
				}
				setPosition(
						chunkcoordinates1.posX + .5d,
						getNextTopBlock(chunkcoordinates1.posX, chunkcoordinates1.posY, chunkcoordinates1.posZ)
								,
								chunkcoordinates1.posZ + .5d);
				GuiChooserPlayerToFind.throwParticles(this, new Random(),
						worldObj);
				setEntityHealth(getMaxHealth());
				deathTime = 0;
				dead = false;
				respawn = true;
			}
		}

	}
	
	

	@Override
	public void onItemPickup(Entity entity2, int i) {
		super.onItemPickup(entity2, i);
		if (entity2 instanceof EntityItem) {
			ItemStack i2 = ((EntityItem) entity2).item;
			int specialId = Item.speckledMelon.shiftedIndex;
			if (i2.itemID == specialId) {
				for (int a = 0; a < i; a++) {
					if (scale < maxScale) {
						if (inventory.consumeInventoryItem(specialId)) {
							scale += .05f;
						}
					}
				}
			} else {
				checkArmor();
			}
		}
		say("pickup");
	}

	// TODO OnUpdate
	@Override
	public void onLivingUpdate() {
		super.onLivingUpdate();
		if (scale < maxScale || justLoaded) {
			scale += .00001f * scale;
			setSize(.6f * (scale > 1.1f ? 1.1f : scale),
					1.8f * (scale > 1.1f ? 1.1f : scale));
			yOffset = (1.62F * (scale > 1.1f ? 1.1f : scale)) - .2f;
			if (scale - lastScaleCheck > .05 || scale - lastScaleCheck < -.05
					|| justLoaded) {
				lastScaleCheck = scale;
				setPosition(posX, posY + .1, posZ);
			}
		} else if (scale > maxScale) {
			scale = (maxScale);
		}
		if (foodCoolDown > 0) {
			foodCoolDown--;
		}
		if (checkPlayerTimer > 0) {
			checkPlayerTimer--;
		}

		if (entityToAttack == null && foodCoolDown == 0 && foodStats.needFood()
				&& rand.nextFloat() < .04f) {
			if(rand.nextInt(20) == 10){
				say("hungry");
			}
			tryEat();
		}
		if (justLoaded) {
			addToPlayerList();
			worldObj.obtainEntitySkin(this);
			if(livingTime == 0 && !chestLoadedTemp){
				chestLoadedTemp = true;
				loadItemsFromDefaultFromChest((int)(Math.floor(posX)), (int)(Math.floor(posY)), (int)(Math.floor(posZ)));
			}
			justLoaded = false;
		}
		if (isMining && blockToBreak != null) {
			onMine();
		}
		if (checkMobTimer > 0) {
			checkMobTimer--;
		}
		if (livingTime == 0) {
			spawnX = (int) Math.floor(posX);
			spawnY = (int) Math.floor(posY);
			spawnZ = (int) Math.floor(posZ);
			if(mod_MyPeople.defaultPerson != null){
				loadDataFromOtherPlayer(mod_MyPeople.defaultPerson);
			}
		}
		if(options.travel){
			if(inPortal){
				timeInPortal += 0.0125F;

		        if (timeInPortal >= 1.0F)
		        {
		            timeInPortal = 1.0F;

		            if (!worldObj.isRemote)
		            {
		                timeUntilPortal = 10;
		                byte byte0 = 0;

		                if (dimension == -1)
		                {
		                    byte0 = 0;
		                }
		                else
		                {
		                    byte0 = -1;
		                }

		                mod_MyPeople.instance.teleport(this, byte0);
		            }
		        }

		        inPortal = false;
			}else{
	            if (timeInPortal > 0.0F)
	            {
	                timeInPortal -= 0.05F;
	            }

	            if (timeInPortal < 0.0F)
	            {
	                timeInPortal = 0.0F;
	            }
	        }

	        if (timeUntilPortal > 0)
	        {
	            timeUntilPortal--;
	        }
	        int x = (int)(Math.floor(posX));
	        int y = (int)(Math.floor(posY));
	        int z = (int)(Math.floor(posZ));
	        int id = worldObj.getBlockId(x, y, z);
	        if(id == Block.portal.blockID){
	        	inPortal = true;
	        }else if(id == Block.endPortal.blockID){
	        	mod_MyPeople.instance.teleport(this, dimension==0?1:0);
	        }
	        
		}
		
		if(getAir() <= 20 && !lastAir){
			say("drown");
		}
		lastAir = getAir() <= 20;
		if(fallDistance >= 4 && !lastFall){
			say("falling");
		}
		lastFall = fallDistance >= 4;
		if(isBurning() && !lastFire){
			say("onFire");
		}else if(!isBurning() && lastFire){
			say("offFire");
		}
		lastFire = isBurning();
		
		if(options.chat && livingTime % 50 == 0 && worldObj.rand.nextInt(20) == 0 && mod_MyPeople.instance.talkCountdown <= 0){
			if(ModLoader.getMinecraftInstance().thePlayer.getDistanceSqToEntity(this) < 100){
				chat.sayRandom(this);
				mod_MyPeople.instance.talkCountdown = 400;
			}
		}
		livingTime++;
	}
	boolean lastFire = false, lastFall = false, lastAir = false;
	public boolean teleportNextToEntity(Entity e){
        int i = MathHelper.floor_double(e.posX) - 2;
        int j = MathHelper.floor_double(e.posZ) - 2;
        int k = MathHelper.floor_double(e.boundingBox.minY);
        ArrayList<double[]> valids = new ArrayList<double[]>();
        for (int l = 0; l <= 4; l++)
        {
            for (int i1 = 0; i1 <= 4; i1++)
            {
                if ((l < 1 || i1 < 1 || l > 3 || i1 > 3) && worldObj.isBlockNormalCube(i + l, k - 1, j + i1) && !worldObj.isBlockNormalCube(i + l, k, j + i1) && !worldObj.isBlockNormalCube(i + l, k + 1, j + i1))
                {
                	valids.add(new double[]{(float)(i + l) + 0.5F, k, (float)(j + i1) + 0.5F});
                }
            }
        }
        if(valids.size() > 0){
        	int id = worldObj.rand.nextInt(valids.size());
        	double[] d = valids.get(id);
        	setLocationAndAngles(d[0], d[1], d[2], rotationYaw, rotationPitch);
        	return true;
        }
        return false;
	}
	

	public void loadDataFromOtherPlayer(EntityMyPerson p) {
		p.options.copyInto(options);
		changeSkin(p.username);
		team = p.team;
	}

	public int getNextTopBlock(int x, int y, int z){
		while(y < 256){
			int id = worldObj.getBlockId(x, y, z);
			if(id == 0){
				id = worldObj.getBlockId(x, y+1, z);
				if(id == 0){
					return y;
				}
			}
			
			y++;
		}
		return y;
	}

	public void onMine() {
		if (blockHitWait > 0) {
			blockHitWait--;
			return;
		}
		swingItem();
		int i = blockToBreak[0];
		int j = blockToBreak[1];
		int k = blockToBreak[2];
		Minecraft mc = ModLoader.getMinecraftInstance();
		if (i == curBlockX && j == curBlockY && k == curBlockZ) {
			int i1 = mc.theWorld.getBlockId(i, j, k);
			if (i1 == 0) {
				return;
			}
			Block block = Block.blocksList[i1];
			curBlockDamage += block.blockStrength(this);
			if (blockDestroySoundCounter % 4F == 0.0F && block != null) {
				try {
					ModLoader.getMinecraftInstance().sndManager.playSound(
							block.stepSound.getStepSound(), i + 0.5F,
							j + 0.5F, k + 0.5F,
							(block.stepSound.getVolume() + 1.0F) / 8F,
							block.stepSound.getPitch() * 0.5F);
				} catch (Exception e) {
				}
			}
			blockDestroySoundCounter++;

			if (curBlockDamage >= 1.0F) {
				onPlayerDestroyBlock(i, j, k);
				curBlockDamage = 0.0F;
				prevBlockDamage = 0.0F;
				blockDestroySoundCounter = 0.0F;
				blockHitWait = 5;
			}
		} else {
			curBlockDamage = 0.0F;
			prevBlockDamage = 0.0F;
			blockDestroySoundCounter = 0.0F;
			curBlockX = i;
			curBlockY = j;
			curBlockZ = k;
		}
	}

	public boolean onPlayerDestroyBlock(int i, int j, int k) {
		int i1 = worldObj.getBlockId(i, j, k);
		int j1 = worldObj.getBlockMetadata(i, j, k);
		boolean flag = onPlayerDestroyBlock2(i, j, k);
		ItemStack itemstack = this.getCurrentEquippedItem();
		boolean flag1 = this.canHarvestBlock(Block.blocksList[i1]);
		if (itemstack != null) {
			itemstack.onDestroyBlock(i1, i, j, k, this);
			if (itemstack.stackSize == 0) {
				itemstack.onItemDestroyedByUse(this);
				destroyCurrentEquippedItem();
				say("break");
			}
		}
		if (flag && flag1) {
			Block.blocksList[i1].harvestBlock(worldObj, this, i, j, k, j1);
			stopMining();
			postBlockDestroy(Block.blocksList[i1].getClass(), new int[] { i, j,
				k });
		}
		return flag;
	}

	public boolean onPlayerDestroyBlock2(int i, int j, int k) {
		World world = worldObj;
		Block block = Block.blocksList[world.getBlockId(i, j, k)];
		if (block == null) {
			return false;
		}
		try {
			world.playAuxSFX(2001, i, j, k,
					block.blockID + (world.getBlockMetadata(i, j, k) << 12));
		} catch (Exception e) {
			System.out.println("Could Not Play Stupid Sound!   ID:"
					+ block.blockID + " META:"
					+ (world.getBlockMetadata(i, j, k)));
			e.printStackTrace();
		}
		int i1 = world.getBlockMetadata(i, j, k);
		boolean flag = world.setBlockWithNotify(i, j, k, 0);
		if (block != null && flag) {
			block.onBlockDestroyedByPlayer(world, i, j, k, i1);
		}
		return flag;
	}

	public void placeBlock(int[] blockPosition, ItemStack stackToUseToPlace) {
		blockToPlace = blockPosition;
		toUse = stackToUseToPlace;
		setPathToBlock(blockPosition);
	}

	public void placeTheBlock() {
		if (toUse != null && blockToPlace != null && toUse.stackSize > 0) {
			swingItem();
			toUse.getItem().onItemUse(toUse, this, worldObj, blockToPlace[0],
					blockToPlace[1], blockToPlace[2], 1);
		}
		toUse = null;
		blockToPlace = null;
		// pathToEntity = null;
	}

	public void postBlockDestroy(Class blockDestroyed, int[] pos) {
		if (BlockCrops.class.isAssignableFrom(blockDestroyed)) {
			if (pos[1] - 1 > 0) {
				int blockID = worldObj.getBlockId(pos[0], pos[1] - 1, pos[2]);
				if (Block.tilledField.blockID == blockID) {
					useSeeds(pos);
				}
			}
		}
	}

	public boolean preBlockDestroy(Class blockDestroyed, int[] pos) {
		if (BlockCrops.class.isAssignableFrom(blockDestroyed)) {
			if (worldObj.getBlockMetadata(pos[0], pos[1], pos[2]) != 7) {
				return false;
			}
		} else if (BlockReed.class.isAssignableFrom(blockDestroyed)) {
			if (pos[1] < 2) {
				return false;
			}
			if (worldObj.getBlockId(pos[0], pos[1] - 1, pos[2]) != Block.reed.blockID) {
				return false;
			}
		} else if (BlockPumpkin.class.isAssignableFrom(blockDestroyed)
				|| BlockMelon.class.isAssignableFrom(blockDestroyed)) {
			int[][] poss = getSurroundingPositions(pos);
			boolean toReturn = false;
			for (int a = 0; a < 4; a++) {
				int id = worldObj
						.getBlockId(poss[a][0], poss[a][1], poss[a][2]);
				int meta = worldObj.getBlockMetadata(poss[a][0], poss[a][1],
						poss[a][2]);
				if (id == Block.pumpkinStem.blockID
						|| id == Block.melonStem.blockID) {
					if (meta >= 7) {
						toReturn = true;
						break;
					}
				}
			}
			return toReturn;
		}

		return true;
	}

	@Override
	public void readEntityFromNBT(NBTTagCompound nbttagcompound) {
		super.readEntityFromNBT(nbttagcompound);
		scale = nbttagcompound.getFloat("scale");
		username = nbttagcompound.getString("username");
		skinUrl = (new StringBuilder())
				.append("http://s3.amazonaws.com/MinecraftSkins/")
				.append(username).append(".png").toString();
		lastScaleCheck = nbttagcompound.getFloat("lastScaleCheck");
		guardPositions[0] = nbttagcompound.getDouble("guardPositions[0]");
		guardPositions[1] = nbttagcompound.getDouble("guardPositions[1]");
		guardPositions[2] = nbttagcompound.getDouble("guardPositions[2]");
		guardPositions[3] = nbttagcompound.getDouble("guardPositions[3]");
		setPosition(posX, posY + (maxScale + .5f - scale), posZ);
		name = nbttagcompound.getString("name");
		texture = nbttagcompound.getString("texture");
		options.read(nbttagcompound);
		livingTime = nbttagcompound.getLong("livingTime");
		spawnX = nbttagcompound.getInteger("spawnX");
		spawnY = nbttagcompound.getInteger("spawnY");
		spawnZ = nbttagcompound.getInteger("spawnZ");
		int teamID = nbttagcompound.getInteger("team");
		team = mod_MyPeople.Team.getByID(teamID);
		if (health <= 0) {
			isDead = true;
		}
	}

	public void removeFromPlayerList() {
		if (worldObj.playerEntities.contains(this)) {
			worldObj.playerEntities.remove(this);
		}
	}

	@Override
	public void setDead() {
		if (!respawn) {
			isDead = true;
		} else {
			respawn = false;
		}
	}
	public void setGuardPositions() {
		guardPositions[0] = posX;
		guardPositions[1] = Math.ceil(posY - 1);
		guardPositions[2] = posZ;
		guardPositions[3] = (ModLoader.getMinecraftInstance().theWorld.getWorldInfo().getDimension());
	}
	public void setPathToBlock(int[] pos) {
		pathToEntity = getEntityPathToXYZ(pos[0], pos[1], pos[2], 20F);
	}
	private ArrayList<int[]> sort(ArrayList<int[]> blocksToMines) {
		ArrayList<int[]> ret = new ArrayList<int[]>();
		int limit = 4000;
		while (blocksToMines.size() > 0 && limit-- > 0) {
			int closest = getClosest(blocksToMines);
			if (closest > -1) {
				ret.add(blocksToMines.get(closest));
				blocksToMines.remove(closest);
			}
		}
		return ret;
	}
	public void startMining() {
		int id = worldObj.getBlockId(blockToBreak[0], blockToBreak[1],
				blockToBreak[2]);
		if (switchTool(id)) {
			isMining = true;
		}

	}
	public void stopMining() {
		curBlockDamage = 0.0F;
		blockHitWait = 0;
		isMining = false;
		inventory.currentItem = 0;
		blockToBreak = null;
		pathToEntity = null;
	}
	public void swapItems(int armorSlotID, int slotID) {
		ItemStack stack1 = inventory.armorItemInSlot(armorSlotID);
		ItemStack stack2 = inventory.getStackInSlot(slotID);
		inventory.setInventorySlotContents(slotID, stack1);
		inventory.setInventorySlotContents(armorSlotID
				+ inventory.mainInventory.length, stack2);
	}

	public boolean switchTool(int blockID) {
		if (blockID > 0 && blockID < 256) {
			Block block = Block.blocksList[blockID];
			if (block != null) {
				Material m = block.blockMaterial;
				boolean b = false;
				if (isMaterial(new Material[] { Material.rock, Material.iron,
						Material.ice, Material.circuits }, m)) {
					b = changeToItemTool(ItemPickaxe.class);
				} else if (isMaterial(new Material[] { Material.wood,
						Material.leaves, Material.pumpkin }, m)) {
					b = changeToItemTool(ItemAxe.class);
					if (!b && m.equals(Material.leaves)) {
						changeToItemTool(ItemSword.class);
					}
				} else if (isMaterial(new Material[] { Material.grass,
						Material.ground }, m)) {
					b = changeToItemTool(ItemSpade.class);
				}
				if (m.isHarvestable()) {
					b = true;
				}
				return b;
			}
		}
		return false;
	}

	public void tryEat() {
		boolean foundGood = false;
		boolean foundBad = false;
		ArrayList<Integer> good = new ArrayList<Integer>();
		ArrayList<Integer> bad = new ArrayList<Integer>();
		for (int a = 0; a < inventory.getSizeInventory(); a++) {
			ItemStack item = inventory.getStackInSlot(a);
			if (item != null
					&& Item.itemsList[item.itemID] != null
					&& ItemFood.class
					.isAssignableFrom(Item.itemsList[item.itemID]
							.getClass())) {
				if (isBad(item)) {
					foundBad = true;
					bad.add(a);
				} else {
					foundGood = true;
					good.add(a);
				}
			}
		}
		if (foundGood || foundBad) {
			ItemStack item = inventory.getStackInSlot(foundGood ? good.get(rand
					.nextInt(good.size())) : bad.get(rand.nextInt(bad.size())));
			foodCoolDown = 25;
			updateItemUse(item, 6);
			item.getItem().onFoodEaten(item, worldObj, this);
		} else {
			tryEatCake();
		}
	}

	private void tryEatCake() {
		ArrayList<Class> list = new ArrayList<Class>();
		list.add(BlockCake.class);
		ArrayList<int[]> blocks = getBlocksByClass(list);
		if (blocks.size() > 0) {
			blocks = sort(blocks);
			for (int a = 0; a < blocks.size(); a++) {
				int[] pos = blocks.get(a);
				BlockPositionEntry b = canSeeBlock(pos[0], pos[1], pos[2]);
				if (b != null && (b.canSeeAtAll || b.m == null)) {
					setPathToBlock(pos);
					eatCake = true;
					cakeToEat = pos;
					break;
				}
			}
		}

	}

	@Override
	protected void updateEntityActionState() {
		entityAge++;
		EntityPlayer entityplayer = worldObj
				.getClosestPlayerToEntity(this, -1D);
		despawnEntity();
		moveStrafing = 0.0F;
		moveForward = 0.0F;
		float f = 8F;

		if (currentTarget != null) {
			faceEntity(currentTarget, 10F, getVerticalFaceSpeed());
			if (numTicksToChaseTarget-- <= 0 || currentTarget.isDead
					|| currentTarget.getDistanceSqToEntity(this) > (f * f)) {
				currentTarget = null;
			}
		} else if (options.curious) {
			if (rand.nextFloat() < 0.05F) {
				randomYawVelocity = (rand.nextFloat() - 0.5F) * 20F;
			}
			rotationYaw += randomYawVelocity;
			rotationPitch = defaultPitch;
		}
		boolean flag = isInWater();
		boolean flag1 = handleLavaMovement();
		if (flag || flag1) {
			isJumping = rand.nextFloat() < 0.8F;
		}

		updateMovements();
		super.updateEntityActionState();
	}

	@Override
	protected void updateFallState(double par1, boolean par3) {
		if (par3) {
			if (fallDistance > 0.0F) {
				if (this instanceof EntityLiving) {
					int i = MathHelper.floor_double(posX);
					int j = MathHelper.floor_double(posY - 0.20000000298023224D
							- yOffset);
					int k = MathHelper.floor_double(posZ);
					int l = worldObj.getBlockId(i, j, k);

					if (l == 0
							&& worldObj.getBlockId(i, j - 1, k) == Block.fence.blockID) {
						l = worldObj.getBlockId(i, j - 1, k);
					}

					if (l > 0 && l != Block.tilledField.blockID) {
						Block.blocksList[l].onFallenUpon(worldObj, i, j, k,
								this, fallDistance);
					}
				}

				fall(fallDistance);
				fallDistance = 0.0F;
			}
		} else if (par1 < 0.0D) {
			fallDistance -= par1;
		}
	}
	
	public boolean canTravel(EntityPlayer player){
		if(options.travel && player.getDistanceToEntity(this) < 10){
			return true;
		}
		System.out.println(options.travel + "|" + player.getDistanceToEntity(this) + name);
		return false;
	}

	///TODO UPDATEMOVEMENTS
	private void updateMovements() {
		Profiler.startSection("ai");
		hasAttacked = false;
		float f = 24F;
		if(runningFromCreeper && (pathToEntity == null || isFarAwayEnough(runningFrom, 6d))){
			runningFromCreeper = false;
			entityToAttack = runningFrom;
			runningFrom = null;
		}
		if(entityToAttack == null && blockToBreak == null && blockToPlace == null && inventory.currentItem != 0){
			inventory.currentItem = 0;
		}
		if (entityToAttack == null && !runningFromCreeper) {
			entityToAttack = findEntityToAttack();
			if (entityToAttack != null) {
				pathToEntity = getPathToEntity(entityToAttack, f);
				if(pathToEntity != null){
					say("runattack");
				}
			}
		} else if (entityToAttack != null && !entityToAttack.isEntityAlive()) {
			entityToAttack = null;
			pathToEntity = null;
			currentTarget = null;
		} else if (entityToAttack != null) {
			float f1 = entityToAttack.getDistanceToEntity(this);
			if (canEntityBeSeen(entityToAttack)
					&& ((options.jump && !isCollidedVertically ? fallDistance > 0.0
							: true) || f1 < 1.5f)) {
				attackEntity(entityToAttack, f1);
			}
			if (checkMobTimer <= 0) {
				checkMobTimer = rand.nextInt(20) + 10;
				Entity e = findEntityToAttack();
				if (e != null
						&& entityToAttack != null
						&& e.getDistanceSqToEntity(this) < entityToAttack
						.getDistanceSqToEntity(this)) {
					entityToAttack = e;
					pathToEntity = getPathToEntity(entityToAttack, f);
				}
			}
		}
		if(!options.fight && entityToAttack != null && entityToAttack instanceof EntityPlayer){
			entityToAttack = null;
			pathToEntity = null;
		}
		if (entityToAttack != null && !options.huntAnimal
				&& entityToAttack instanceof EntityAnimal) {
			entityToAttack = null;
		}
		if (entityToAttack != null && !options.huntMob
				&& entityToAttack instanceof EntityMob) {
			entityToAttack = null;
		}
		if (entityToAttack == null && pathToEntity == null
				&& entityToMount == null && !runningFromCreeper) {
			if (checkPlayerTimer <= 0) {
				if (!findXPOrItemstacksAndSetCourse() && !options.guard) {
					checkPlayerAndRun();
				}
				checkPlayerTimer = 7;
			}
		}
		if(entityToAttack != null && entityToAttack instanceof EntityMyPerson){
			EntityMyPerson toAttack = (EntityMyPerson)entityToAttack;
			if(!canAttackEachother(toAttack)){
				entityToAttack = null;
				pathToEntity = null;
			}
		}
		if(entityToAttack != null && entityToAttack.getClass().equals(ModLoader.getMinecraftInstance().thePlayer.getClass()) && !isTraitor()){
			entityToAttack = null;
			pathToEntity = null;
		}
		if(entityToAttack != null && entityToAttack instanceof EntityCreeper){
			EntityCreeper c = (EntityCreeper)entityToAttack;
			if((hasAttacked || c.timeSinceIgnited > 0) && c.getCreeperState() > 0){
				if(runFromEntityLiving(c)){
					say("runcreeper");
				}
			}
		}
		if (blockToBreak == null && entityToAttack == null
				&& pathToEntity != null && eatCake && cakeToEat != null) {
			setPathToBlock(cakeToEat);
		}
		if (blockToBreak == null && entityToAttack == null
				&& pathToEntity == null && eatCake && cakeToEat != null) {
			double d = this.getDistance(cakeToEat);
			if (d < 16) {
				Block.cake.blockActivated(worldObj, cakeToEat[0], cakeToEat[1],
						cakeToEat[2], this);
				pathToEntity = null;
				eatCake = false;
				cakeToEat = null;
			}
		}

		if (blockToBreak == null && entityToAttack == null
				&& entityToMount == null) {
			ArrayList<Class> blocksToBreak = new ArrayList<Class>();
			if (options.lumber) {
				blocksToBreak.add(BlockLog.class);
			}
			if (options.mine) {
				blocksToBreak.add(BlockOre.class);
				blocksToBreak.add(BlockRedstoneOre.class);
			}
			if (options.farm) {
				blocksToBreak.add(BlockPumpkin.class);
				blocksToBreak.add(BlockMelon.class);
				blocksToBreak.add(BlockReed.class);
				blocksToBreak.add(BlockCrops.class);
			}
			findAndBreakBlocks(blocksToBreak);
		}
		if (isMining && entityToAttack != null) {
			stopMining();
			blockToBreak = null;
		}
		if (blockToBreak != null) {
			double d = getDistance(blockToBreak);
			if (d <= 16 && !isMining) {
				startMining();
				say("mine");
			} else if (d > 16 && isMining) {
				stopMining();
			}
		}
		if (blockToPlace != null) {
			double d = getDistance(blockToPlace);
			if (d <= 16 && !isMining) {
				placeTheBlock();
			}
		}
		if (blockToBreak != null && pathToEntity == null) {
			setPathToBlock(blockToBreak);
		}
		if (blockToPlace != null && pathToEntity == null && toUse != null) {
			setPathToBlock(blockToPlace);
		}
		 checkBlockValid();
		if (entityToAttack != null
				&& ((EntityLiving) entityToAttack).isMovementBlocked()) {
			entityToAttack = null;
			pathToEntity = null;
			currentTarget = null;
		}
		if (pathToEntity == null && entityToAttack != null) {
			pathToEntity = getPathToEntity(entityToAttack, f);
			if (pathToEntity == null) {
				entityToAttack = null;
				pathToEntity = null;
			}
		}
		// START
		if (blockToBreak != null && isMining && entityToAttack == null) {
			faceBlock(blockToBreak, 30F, getVerticalFaceSpeed());
		}
		if (entityToAttack == null && options.farm && pathToEntity == null
				&& ridingEntity == null && blockToPlace == null) {
			ItemStack stack = hasItem(Item.seeds);
			if (stack != null) {
				checkToPlantCrops(stack);
			}
		}
		if (entityToAttack == null
				&& pathToEntity == null
				&& !isMining
				&& options.boat
				&& ModLoader.getMinecraftInstance().thePlayer.ridingEntity instanceof EntityBoat
				&& options.follow && ridingEntity == null) {
			List entities = worldObj.getEntitiesWithinAABB(
					net.minecraft.src.EntityBoat.class,
					AxisAlignedBB.getBoundingBoxFromPool(posX, posY, posZ,
							posX + 1.0D, posY + 1.0D, posZ + 1.0D).expand(16D,
									4D, 16D));
			if (entities.size() > 1) {
				EntityBoat boat = null;
				int close = getClosestUnmountedEntityFromList(entities);
				if (close > -1) {
					boat = (EntityBoat) entities.get(close);
					if (boat != null) {
						setEntityToMount(boat, f);
					}
				}
			}

		}
		if (entityToMount != null && !entityToMount.isEntityAlive()) {
			entityToMount = null;
		}
		if ((ridingEntity != null
				&& (!ridingEntity.isEntityAlive() || ridingEntity instanceof EntityBoat
						&& ModLoader.getMinecraftInstance().thePlayer.ridingEntity == null))) {
			dismountFromEntity();
		}
		if (entityToAttack == null && !isMining && inventory.currentItem > 0) {
			inventory.currentItem = 0;
		}

		// STOP
		if ((runningFromCreeper || entityToAttack != null) && pathToEntity != null && options.sprint
				&& !isCollidedHorizontally) {
			if (!isSprinting() && this.foodStats.getFoodLevel() > 4) {
				setSprinting(true);
			}
		} else {
			if (isSprinting()) {
				setSprinting(false);
			}
		}

		Profiler.endSection();
		if (!hasAttacked && entityToAttack != null
				&& (pathToEntity == null || rand.nextInt(20) == 0) && !(entityToAttack instanceof EntityCreeper)) {
			pathToEntity = getPathToEntity(entityToAttack, f);
		} else if (options.wander
				&& !hasAttacked
				&& (pathToEntity == null && rand.nextInt(180) == 0 || rand
				.nextInt(120) == 0) && entityAge < 100
				&& (!options.guard) && ridingEntity == null
				&& riddenByEntity == null && entityToMount == null) {
			updateWanderPath();
		}

		int i = MathHelper.floor_double(boundingBox.minY + 0.5D);
		boolean flag = isInWater();
		boolean flag1 = handleLavaMovement();
		rotationPitch = 0.0F;
		if (pathToEntity == null || rand.nextInt(100) == 0) {
			super.updateEntityActionState();
			pathToEntity = null;
			return;
		}

		Profiler.startSection("followpath");
		Vec3D vec3d = pathToEntity.getCurrentNodeVec3d(this);
		for (double d = width * 2.0F; vec3d != null
				&& vec3d.squareDistanceTo(posX, vec3d.yCoord, posZ) < d * d;) {
			pathToEntity.incrementPathIndex();
			if (pathToEntity.isFinished()) {
				vec3d = null;
				pathToEntity = null;
			} else {
				vec3d = pathToEntity.getCurrentNodeVec3d(this);
			}
		}

		isJumping = false;
		if (vec3d != null) {
			double d1 = vec3d.xCoord - posX;
			double d2 = vec3d.zCoord - posZ;
			double d3 = vec3d.yCoord - i;
			float f2 = (float) ((Math.atan2(d2, d1) * 180D) / 3.1415927410125732D) - 90F;
			float f3 = f2 - rotationYaw;
			moveForward = moveSpeed;
			for (; f3 < -180F; f3 += 360F) {
			}
			for (; f3 >= 180F; f3 -= 360F) {
			}
			if (f3 > 30F) {
				f3 = 30F;
			}
			if (f3 < -30F) {
				f3 = -30F;
			}
			rotationYaw += f3;
			if (hasAttacked && entityToAttack != null) {
				double d4 = entityToAttack.posX - posX;
				double d5 = entityToAttack.posZ - posZ;
				float f5 = rotationYaw;
				rotationYaw = (float) ((Math.atan2(d5, d4) * 180D) / 3.1415927410125732D) - 90F;
				float f4 = (((f5 - rotationYaw) + 90F) * 3.141593F) / 180F;
				moveStrafing = -MathHelper.sin(f4) * moveForward * 1.0F;
				moveForward = MathHelper.cos(f4) * moveForward * 1.0F;
			}
			if (d3 > 0.0D) {
				isJumping = true;
			}
		}
		if (entityToMount != null && entityToAttack == null
				&& this.getDistanceSqToEntity(entityToMount) < 9) {
			mountEntity(entityToMount);
			entityToMount = null;
		}
		if (entityToAttack != null) {
			faceEntity(entityToAttack, 30F, 30F);
		}
		if (options.jump
				&& entityToAttack != null
				&& isCollidedVertically
				&& this.getDistanceSqToEntity(entityToAttack) < (options.sprint ? 28
						: 10)
						&& this.getDistanceSqToEntity(entityToAttack) > (options.sprint ? 22
								: 5)) {
			jump();
		}


		if (rand.nextFloat() < 0.8F && (flag || flag1)) {
			isJumping = true;
		}
		Profiler.endSection();
	}
	
	public void dismountFromEntity() {
		if(ridingEntity != null){
			ridingEntity.riddenByEntity = null;
			ridingEntity = null;
		}
		entityToMount = null;
	}

	public boolean setEntityToMount(Entity e, float f){
		if(e.getDistanceSqToEntity(this) > 500){
			return false;
		}
		entityToMount = e;
		pathToEntity = getPathToEntity(e, f);
		return true;
	}
	
	private boolean isFarAwayEnough(Entity entityToAttack2, double d) {
		if(entityToAttack2 != null){
			double d2 = this.getDistanceSq(entityToAttack2.posX, entityToAttack2.posY, entityToAttack2.posZ);
			double d3 = d*d;
			if(d2 > d3){
				return true;
			}
		}
		return false;
	}
	boolean runningFromCreeper = false;
	EntityLiving runningFrom = null;
	private boolean runFromEntityLiving(EntityLiving c) {
		double x = posX - c.posX;
		double y = posY - c.posY;
		double z = posZ - c.posZ;
		int limit = 20;
		while(c.getDistanceSq(c.posX+x, c.posY+y, c.posZ+z) < 80 && limit -- > 0){
			x*= 1.1;
			z*= 1.1;
		}
		if(limit > 0){
			int x1 = (int)Math.round(c.posX+x);
			int z1 = (int)Math.round(c.posZ+z);
			int y1 = getNextBlock(x1, (int)Math.round(c.posY+y), z1);
			System.out.println(x1 + "|" + y1 + "|" + z1);
			pathToEntity = getEntityPathToXYZ(x1, y1, z1, 5f);
			
			if(pathToEntity != null){
				entityToAttack = null;
				runningFromCreeper = true;
				return true;
			}
		}
		return true;
	}

	private int getNextBlock(int x1, int y1, int z1) {
		int x = x1;
		int z = z1;
		int y = y1;
		if(y < 1 || y > 255){
			return y;
		}
		int max = 258; //256+2 for good measure
		while(max-- > 0 && worldObj.getBlockId(x, y, z) == 0){
			y--;
		}
		max = 258;
		while(max-- > 0 && worldObj.getBlockId(x, y, z) != 0){
			y++;
		}
		return y;
	}

	public boolean canAttackEachother(EntityMyPerson other){
		boolean b = (!other.equals(this) && other.options.fight && options.fight && ((!other.team.equals(team) && !other.team.equals(Team.Good)? !isTraitor():false)||(team.equals(Team.Good) && !other.team.equals(team)?!other.isTraitor():false) || team.equals(Team.Traitor)));
		return b;
	}

	private float updateRotation(float f, float f1, float f2) {
		float f3;
		for (f3 = f1 - f; f3 < -180F; f3 += 360F) {
		}
		for (; f3 >= 180F; f3 -= 360F) {
		}
		if (f3 > f2) {
			f3 = f2;
		}
		if (f3 < -f2) {
			f3 = -f2;
		}
		return f + f3;
	}

	protected void updateWanderPath() {
		Profiler.startSection("stroll");
		boolean flag = false;
		int i = -1;
		int j = -1;
		int k = -1;
		float f = -99999F;
		for (int l = 0; l < 10; l++) {
			int i1 = MathHelper.floor_double((posX + rand.nextInt(13)) - 6D);
			int j1 = MathHelper.floor_double((posY + rand.nextInt(7)) - 3D);
			int k1 = MathHelper.floor_double((posZ + rand.nextInt(13)) - 6D);
			float f1 = getBlockPathWeight(i1, j1, k1);
			if (f1 > f) {
				f = f1;
				i = i1;
				j = j1;
				k = k1;
				flag = true;
			}
		}

		if (flag) {
			pathToEntity = getEntityPathToXYZ(i, j, k, 10F);
		}
		Profiler.endSection();
	}

	private void useSeeds(int[] pos) {
		ItemStack stack = hasItem(Item.seeds);
		if (stack != null && stack.itemID == Item.seeds.shiftedIndex) {
			Item.seeds.onItemUse(stack, this, worldObj, pos[0], pos[1] - 1,
					pos[2], 1);
		}
	}

	@Override
	public void writeEntityToNBT(NBTTagCompound nbttagcompound) {
		super.writeEntityToNBT(nbttagcompound);
		nbttagcompound.setString("username", username);
		nbttagcompound.setFloat("scale", scale);
		nbttagcompound.setFloat("lastScaleCheck", lastScaleCheck);
		nbttagcompound.setDouble("guardPositions[0]", guardPositions[0]);
		nbttagcompound.setDouble("guardPositions[1]", guardPositions[1]);
		nbttagcompound.setDouble("guardPositions[2]", guardPositions[2]);
		nbttagcompound.setDouble("guardPositions[3]", guardPositions[3]);
		nbttagcompound.setString("name", name);
		nbttagcompound.setString("texture", texture);
		options.write(nbttagcompound);
		nbttagcompound.setLong("livingTime", livingTime);
		nbttagcompound.setInteger("spawnX", spawnX);
		nbttagcompound.setInteger("spawnY", spawnY);
		nbttagcompound.setInteger("spawnZ", spawnZ);
		nbttagcompound.setInteger("team", team.teamID);
		nbttagcompound.setBoolean("hasSavedFemale", true);
/*		nbttagcompound.setBoolean("female", isFemale);*/
	}
	
	public static Vec3D func_48623_b(EntityMyPerson par0EntityCreature, int par1, int par2, Vec3D par3Vec3D)
    {
		Vec3D field_48624_a = Vec3D.createVectorHelper(0.0D, 0.0D, 0.0D);
        field_48624_a.xCoord = par0EntityCreature.posX - par3Vec3D.xCoord;
        field_48624_a.yCoord = par0EntityCreature.posY - par3Vec3D.yCoord;
        field_48624_a.zCoord = par0EntityCreature.posZ - par3Vec3D.zCoord;
        return func_48621_c(par0EntityCreature, par1, par2, field_48624_a);
    }

    private static Vec3D func_48621_c(EntityMyPerson par0EntityCreature, int par1, int par2, Vec3D par3Vec3D)
    {
        Random random = par0EntityCreature.getRNG();
        boolean flag = false;
        int i = 0;
        int j = 0;
        int k = 0;
        float f = -99999F;
        boolean flag1;

        if (par0EntityCreature.hasHome())
        {
            double d = par0EntityCreature.getHomePosition().getEuclideanDistanceTo(MathHelper.floor_double(par0EntityCreature.posX), MathHelper.floor_double(par0EntityCreature.posY), MathHelper.floor_double(par0EntityCreature.posZ)) + 4D;
            flag1 = d < (double)(par0EntityCreature.getMaximumHomeDistance() + (float)par1);
        }
        else
        {
            flag1 = false;
        }

        for (int l = 0; l < 10; l++)
        {
            int i1 = random.nextInt(2 * par1) - par1;
            int j1 = random.nextInt(2 * par2) - par2;
            int k1 = random.nextInt(2 * par1) - par1;

            if (par3Vec3D != null && (double)i1 * par3Vec3D.xCoord + (double)k1 * par3Vec3D.zCoord < 0.0D)
            {
                continue;
            }

            i1 += MathHelper.floor_double(par0EntityCreature.posX);
            j1 += MathHelper.floor_double(par0EntityCreature.posY);
            k1 += MathHelper.floor_double(par0EntityCreature.posZ);

            if (flag1 && !par0EntityCreature.isWithinHomeDistance(i1, j1, k1))
            {
                continue;
            }

            float f1 = par0EntityCreature.getBlockPathWeight(i1, j1, k1);

            if (f1 > f)
            {
                f = f1;
                i = i1;
                j = j1;
                k = k1;
                flag = true;
            }
        }

        if (flag)
        {
            return Vec3D.createVector(i, j, k);
        }
        else
        {
            return null;
        }
    }

	public void loadFromPrevious(EntityMyPerson clone) {
		NBTTagCompound c = new NBTTagCompound();
		clone.writeToNBT(c);
		this.readFromNBT(c);
	}

	public void doKill() {
		removeFromPlayerList();
		if (mod_MyPeople.entityToFind != null
				&& mod_MyPeople.entityToFind.equals(this)) {
			mod_MyPeople.entityToFind = null;
		}
		super.onDeath(DamageSource.generic);
		dead = true;
		health = 0;
		GuiChooserPlayerToFind.throwParticles(this, new Random(), worldObj);
	}
	boolean chestLoadedTemp = false;
	public void loadItemsFromDefaultFromChest(int posX, int posY, int posZ){
		chestLoadedTemp = true;
		if(mod_MyPeople.defaultPerson != null){
			ArrayList<TileEntityChest> chests = new ArrayList<TileEntityChest>();
			for(int x = posX-2; x <= posX+2; x++){
				for(int y = posY-1; y <= posY + 1; y++){
					for(int z = posZ-2; z <= posZ+2; z++){
						TileEntity tec = worldObj.getBlockTileEntity(x, y, z);
						if(tec != null && tec instanceof TileEntityChest){
							chests.add((TileEntityChest)tec);
						}
					}
				}
			}
			if(chests.size() > 0){
				InventoryPlayer i = mod_MyPeople.defaultPerson.inventory;
				for(int a = 0; a < i.getSizeInventory(); a++){
					ItemStack item = i.getStackInSlot(a);
					if(item != null){
						int amountNeeded = item.stackSize;
						int amountGot = 0;
						for(int b = 0; b < chests.size(); b++){
							int max = 1000;
							while(max-- > 0 && amountGot < amountNeeded && consumeInventoryItem(item.itemID, chests.get(b))){
								amountGot++;
							}
						}
						if(amountGot > 0){
							inventory.setInventorySlotContents(a, new ItemStack(item.itemID, amountGot, 0));
							if(item.itemID == Item.speckledMelon.shiftedIndex){
								for (int b = 0; b < amountGot; b++) {
									if (scale < maxScale) {
										if (inventory.consumeInventoryItem(item.itemID)) {
											scale += .05f;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}

    private int getInventorySlotContainItem(int par1, TileEntityChest chest, ItemStack[] items)
    {
        for (int i = 0; i < items.length; i++)
        {
            if (items[i] != null && items[i].itemID == par1)
            {
                return i;
            }
        }

        return -1;
    }
	
    public boolean consumeInventoryItem(int par1, TileEntityChest chest)
    {
    	ItemStack[] items = getItems(chest);
        int i = getInventorySlotContainItem(par1, chest, items);

        if (i < 0)
        {
            return false;
        }

        if (--items[i].stackSize <= 0)
        {
        	items[i] = null;
        }

        return true;
    }
	
	public ItemStack[] getItems(TileEntityChest chest){
		if(chest != null){
			try {
				return (ItemStack[])tileEntityChestStackField.get(chest);
			} catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return null;
	}

	static Field tileEntityChestStackField = null;
	static{
		tileEntityChestStackField = loadStackFields();
		chat = PlayerChat.instance;
	}
	
	private static Field loadStackFields() {
		Field[] fields = TileEntityChest.class.getDeclaredFields();
		for(int a = 0; a < fields.length; a++){
			if(fields[a] != null){
				Class c1 = fields[a].getType();
				if((ItemStack[].class).isAssignableFrom(c1)){
					fields[a].setAccessible(true);
					return fields[a];
				}
			}
		}
		return null;
	}
	
	public void sayRandom(String s){
		chat.say(s, this);
	}
	
	public void say(String string) {
		if(!options.talk || !SoundPackage.play1(string, posX, posY, posZ, .8f, .9f + ((1-scale)/.85f) + (worldObj.rand.nextFloat()*.1f), this)){
			if(options.chat && ModLoader.getMinecraftInstance().thePlayer.getDistanceSqToEntity(this) < 100){
				chat.sayAssigned(string, this);
			}
		}
	}

}

