package net.minecraft.src;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import net.minecraft.client.Minecraft;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

public class GuiChooserPlayerToFind extends GuiScreen {

	GuiListBox box;
	ArrayList<EntityMyPerson> entities;
	GuiButton edit, goTo, comeTo;
	int x = 0, xSize = 240;
	int y = 0, ySize = 224;
	double errorDisplayTime = 0d;
	@Override
	public void initGui() {
		controlList.clear();
		entities = getEntitiesFromList(mc.theWorld.playerEntities);
			x = (width-xSize)/2;
			y = (height-ySize)/2;
			int idSelected = -1;
			for(int a = 0; a < entities.size(); a++){
				if(entities.get(a).equals(mod_MyPeople.entityToFind)){
					idSelected = a;
					break;
				}
			}
			String[][] data = getInfoFromPlayers(entities);
			controlList.add(box = new GuiListBox(0, x+8, y+8, 160, 206, data, 4));
			controlList.add(new GuiButton(1, x+178, y+10, 50, 20, "Clear"));
			controlList.add(new GuiButton(2, x+178, y+35, 50, 20, "Done"));
			controlList.add(new GuiButton(3, x+178, y+60, 50, 20, "Universal"));
			controlList.add(edit = new GuiButton(4, x+178, y+85, 50, 20, "Edit"));
			controlList.add(goTo = new GuiButton(5, x+178, y+120, 50, 20, "GoTo"));
			controlList.add(comeTo = new GuiButton(6, x+178, y+145, 50, 20, "ComeTo"));
			controlList.add(new GuiButton(7, x+178, y+175, 50, 20, "Defaults"));
			
			if(box.idSelected < 0){
				edit.enabled = false;
				goTo.enabled = false;
				comeTo.enabled = false;
			}
			box.idSelected = idSelected;

	}
	
	public String[][] getInfoFromPlayers(ArrayList<EntityMyPerson> entities) {
		String[][] data = new String[entities.size()][3];
		for(int a = 0; a < entities.size(); a++){
			EntityMyPerson e = entities.get(a);
			data[a][0] = e.name + "  (Health: " + e.health + "/"+ e.getMaxHealth() + ")";
			data[a][1] = "X: " + Math.round(e.posX) + "   Y: " + Math.round(e.posY) + "   Z: " + Math.round(e.posZ);
			data[a][2] = "Status: " + (e.entityToAttack!=null?"Attacking " + e.entityToAttack.getEntityString():(e.pathToEntity != null?"Walking":"Waiting"));
		}
		return data;
	}

	public ArrayList<EntityMyPerson> getEntitiesFromList(List l){
		ArrayList<EntityMyPerson> l2 = new ArrayList<EntityMyPerson>();
		for(int a = 0; a < l.size(); a++){
			Entity e = (Entity)l.get(a);
			if(e.getClass().equals(EntityMyPerson.class)){
				l2.add((EntityMyPerson)e);
			}
		}
		return l2;
	}

	public void drawScreen(int i, int j, float f) {
		drawDefaultBackground();

		GL11.glTranslatef(0, 0, 100F);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/MyPeople/findplayers.png"));
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		drawTexturedModalRect(x, y, 0, 0, xSize, ySize);
		GL11.glEnable(GL11.GL_BLEND);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		this.drawCenteredString(mc.fontRenderer, "You or the clone must have redstone to do that function.", width/2, height-9, getColour());
		GL11.glDisable(GL11.GL_BLEND);
		GL11.glColor4f(1, 1, 1, 1);
		super.drawScreen(i, j, f);
		GL11.glTranslatef(0, 0, -100F);
		renderPlayerStuff(i, j);
	}
	
	
	
	

	private void renderPlayerStuff(int i, int j) {
		if(box.idSelected > -1 && box.idSelected < entities.size()){
			EntityLiving e = entities.get(box.idSelected);
			if(e instanceof EntityMyPerson){
				EntityMyPerson p = (EntityMyPerson)e;
				renderEntity(e, i, j, 50, 200, 10, 50);
				if(e != null && e instanceof EntityMyPerson){
					if(p.entityToAttack != null){
						renderEntity((EntityLiving)p.entityToAttack, i, j, width-50, 200, -300, 90);
					}
				}
			}
		}
		
	}

	private int getColour() {
		int alpha = (int)Math.round((errorDisplayTime/100d) *255d);
		if(alpha < 8){
			alpha = 8;
		}
		int out = 0;
		out = (out | alpha) << 24;
		out |= 0xee3300;
		return out;
	}

	@Override
	protected void actionPerformed(GuiButton gb) {
		Random r = new Random();
		if(gb.id == 1){
			if(box != null){
				box.idSelected = -1;
			}
		}else if(gb.id == 2){
			mc.displayGuiScreen(null);
		}else if(gb.id == 3){
			mc.displayGuiScreen(new GuiUniversalPlayerOptions(this));
		}else if(gb.id == 4){
			mc.displayGuiScreen(new GuiMorePeopleOptions(entities.get(box.idSelected), entities.get(box.idSelected).options, this));
		}else if(gb.id == 5){
			boolean tp = true;
			EntityMyPerson e = entities.get(box.idSelected);
			if(mc.thePlayer.inventory.hasItem(Item.redstone.shiftedIndex)){
				mc.thePlayer.inventory.consumeInventoryItem(Item.redstone.shiftedIndex);
			}else if(e.inventory.hasItem(Item.redstone.shiftedIndex)){
				e.inventory.consumeInventoryItem(Item.redstone.shiftedIndex);
			}else{
				tp = false;
			}
			if(tp){
				mc.displayGuiScreen(null);
				mc.thePlayer.setPosition(e.posX+r.nextDouble()-.5, e.posY+.5, e.posZ+r.nextDouble()-.5);
				throwParticles(mc.thePlayer, r, mc.theWorld);
			}else{
				errorDisplayTime = 100d;
			}
		}else if(gb.id == 6){
			boolean tp = true;
			EntityMyPerson e = entities.get(box.idSelected);
			if(mc.thePlayer.inventory.hasItem(Item.redstone.shiftedIndex)){
				mc.thePlayer.inventory.consumeInventoryItem(Item.redstone.shiftedIndex);
			}else if(e.inventory.hasItem(Item.redstone.shiftedIndex)){
				e.inventory.consumeInventoryItem(Item.redstone.shiftedIndex);
			}else{
				tp = false;
			}
			if(tp){
				mc.displayGuiScreen(null);
				e.setPosition(mc.thePlayer.posX+r.nextDouble()-.5, mc.thePlayer.posY, mc.thePlayer.posZ+r.nextDouble()-.5);
				throwParticles(e, r, mc.theWorld);
			}else{
				errorDisplayTime = 100d;
			}
		}else if(gb.id == 7){
			if(mod_MyPeople.defaultPerson == null){
				mod_MyPeople.defaultPerson = new EntityMyPerson(mc.theWorld);
			}
			mc.displayGuiScreen(new GuiTransferPlayerItems(mod_MyPeople.defaultPerson, mc.thePlayer, true));
			//mc.displayGuiScreen(new GuiMorePeopleOptions(mod_MyPeople.defaultPerson, mod_MyPeople.defaultPerson.options, this));
		}
	}

	
	public void renderEntity(EntityLiving thePlayer, int i, int l, int X, int Y, int mouseX, int mouseY){
		GL11.glPushMatrix();
        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
        GL11.glPushMatrix();
        GL11.glTranslatef(X, Y, 50F);
        float f = 50F;
        GL11.glScalef(-f, f, f);
        GL11.glRotatef(180F, 0.0F, 0.0F, 1.0F);
        float f1 = thePlayer.renderYawOffset;
        float f2 = thePlayer.rotationYaw;
        float f3 = thePlayer.rotationPitch;
        float f4 = (float)(10 + 51) - i - mouseX;
        float f5 = (float)((40 + 75) - 50) - l + mouseY;
        GL11.glRotatef(135F, 0.0F, 1.0F, 0.0F);
        RenderHelper.enableStandardItemLighting();
        GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
        GL11.glRotatef(-(float)Math.atan(f5 / 40F) * 20F, 1.0F, 0.0F, 0.0F);
        thePlayer.renderYawOffset = (float)Math.atan(f4 / 40F) * 20F;
        thePlayer.rotationYaw = (float)Math.atan(f4 / 40F) * 40F;
        thePlayer.rotationPitch = -(float)Math.atan(f5 / 40F) * 20F;
        thePlayer.rotationYawHead = thePlayer.rotationYaw;
        GL11.glTranslatef(0.0F, thePlayer.yOffset, 0.0F);
        RenderManager.instance.playerViewY = 180F;
        RenderManager.instance.renderEntityWithPosYaw(thePlayer, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
        thePlayer.renderYawOffset = f1;
        thePlayer.rotationYaw = f2;
        thePlayer.rotationPitch = f3;
        GL11.glPopMatrix();
        RenderHelper.disableStandardItemLighting();
        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
        GL11.glDisable(GL11.GL_COLOR_MATERIAL);
        GL11.glPopMatrix();
	}

	public static void throwParticles(EntityLiving e, Random r, World theWorld) {
		theWorld.playSoundEffect(e.posX, e.posY, e.posZ, "random.explode", 4F, (1.0F + (theWorld.rand.nextFloat() - theWorld.rand.nextFloat()) * 0.1F) * 0.7F);
		double outof = r.nextInt(10)+30;
		for(int a = 0; a < outof; a++){
			double d = ((double)a)/outof*360d;
			double x = 1;
			double z = 1;
			if(d >= 0 && d < 90){
				x *= (90-(d%90));
				z *= (d%90);
			}else if(d >= 90 && d < 180){
				x *= (90-(d%90))*-1;
				z *= (d%90);
			}else if(d >= 180 && d < 270){
				x *= (90-(d%90));
				z *= (d%90)*-1;
			}else{
				x *= (90-(d%90))*-1;
				z *= (d%90)*-1;
			}
			x /= 90;
			z /= 90;
			theWorld.spawnParticle("explode", e.posX+gd(r), e.posY+gd(r), e.posZ+gd(r), x, r.nextDouble()/3, z);
			theWorld.spawnParticle("smoke", e.posX+gd(r), e.posY+gd(r), e.posZ+gd(r), x, r.nextDouble()/3, z);
		}
		for(int a = 0; a < 40; a++){
			theWorld.spawnParticle("reddust", e.posX+gd(r), e.posY+gd(r), e.posZ+gd(r), 1d, r.nextDouble()/6, r.nextDouble()/6);
		}
	}
	
	public static double gd(Random r){
		return (r.nextDouble()*1.5d)-.75d;
	}

	@Override
	public void onGuiClosed() {
		if(box != null){
			int id = box.idSelected;
			if(id > -1 && id < entities.size()){
				Entity e = entities.get(box.idSelected);
				if(e != null){
					mod_MyPeople.entityToFind = e;
				}
			}else{
				mod_MyPeople.entityToFind = null;
			}
		}
	}

	@Override
	public void updateScreen() {
		entities = getEntitiesFromList(mc.theWorld.playerEntities);
		if(entities.size()>0){
			String[][] data = getInfoFromPlayers(entities);
			box.set(data);
		}
		if(box.idSelected > -1 && box.idSelected < entities.size()){
			edit.enabled = true;
			goTo.enabled = true;
			comeTo.enabled = true;
		}else{
			edit.enabled = false;
			goTo.enabled = false;
			comeTo.enabled = false;
		}
		if(errorDisplayTime > 0){
			errorDisplayTime--;
		}
	}
	
	

	@Override
	public boolean doesGuiPauseGame() {
		return false;
	}
	
	
	
	

}
