package net.minecraft.src;

import java.util.ArrayList;

import org.lwjgl.input.Keyboard;

import net.minecraft.src.PersonOptions.Options;

public class GuiMorePeopleOptions extends GuiScreen{
	GuiScreen previousScreen;
	EntityMyPerson person;
	PersonOptions options;
	ArrayList<GuiTextField> textFields = new ArrayList<GuiTextField>();
	int maxDown = 0;
	int maxAcross = 0;
	public GuiMorePeopleOptions(EntityMyPerson myPerson, PersonOptions options, GuiScreen previous){
		previousScreen = previous;
		person = myPerson;
		this.options = options;
	}
	int position = 0;
	int max = 36;

	public void initGui(){
		Keyboard.enableRepeatEvents(true);
		controlList.clear();
		textFields.clear();
		maxDown = height/25;
		maxAcross = width/105;
		max = maxDown*maxAcross;
		addTextField(person != null?person.username:"");
		Options[] ops = PersonOptions.Options.values();
		for(int a = 0; a < ops.length; a++){
			boolean value = options.getValue(ops[a]);
			addToggleButton(ops[a].displayName, value, ops[a].valueName);
		}
		if(person.ridingEntity != null){
			addButton("Dismount Entity", 177);
		}
		controlList.add(new GuiButton(99, (((maxAcross * maxDown)-1) / maxDown)*105, (((maxAcross * maxDown)-1) % maxDown)*25, 100, 20, "Done"));
	}
	
	
	
	
	@Override
	protected void actionPerformed(GuiButton guibutton) {
		if(guibutton.id == 99){
			mc.displayGuiScreen(previousScreen);
		}else if(guibutton.id == 177){
			person.dismountFromEntity();
			controlList.remove(guibutton);
		}
	}
	
	public void addTextField(String value){
		if(position < max){
			int posX = position / maxDown;
			int posY = position % maxDown;
			posX *= 105;
			posY *= 25;
			GuiTextField f;
			textFields.add(f = new GuiTextField(mc.fontRenderer, posX+2, posY+1, 96, 18));
			f.setText(value);
			position++;
		}
	}
	
	public void addButton(String text, int id){
		if(position < max){
			int posX = position / maxDown;
			int posY = position % maxDown;
			posX *= 105;
			posY *= 25;
			controlList.add(new GuiButton(id==-1?position:id, posX, posY, 100, 20, text));
			position++;
		}
	}
	
	public void addToggleButton(String text, boolean value, String  objValue){
		if(position < max){
			int posX = position / maxDown;
			int posY = position % maxDown;
			posX *= 105;
			posY *= 25;
			controlList.add(new ToggleableButton(position, posX, posY, 100, 20, text, value, objValue));
			position++;
		}
	}
	
	
	public void drawScreen(int par1, int par2, float par3) {
		drawDefaultBackground();
		for(int a = 0; a < controlList.size(); a++){
			((GuiButton)controlList.get(a)).drawButton(mc, par1, par2);
		}
		for(int a = 0; a < textFields.size(); a++){
			((GuiTextField)textFields.get(a)).drawTextBox();
		}
	}
	
	
	
	@Override
	protected void keyTyped(char par1, int par2) {
		for(int a = 0; a < textFields.size(); a++){
			textFields.get(a).func_50037_a(par1, par2);
		}
		super.keyTyped(par1, par2);
	}




	@Override
	protected void mouseClicked(int par1, int par2, int par3) {
		for(int a = 0; a < textFields.size(); a++){
			textFields.get(a).mouseClicked(par1, par2, par3);
		}
		super.mouseClicked(par1, par2, par3);
	}




	@Override
	public void updateScreen() {
		for(int a = 0; a < textFields.size(); a++){
			textFields.get(a).updateCursorCounter();
		}
		super.updateScreen();
	}




	public void onGuiClosed() {
		Keyboard.enableRepeatEvents(false);
		for(int a = 0; a < controlList.size(); a++){
			if(controlList.get(a) instanceof ToggleableButton){
				checkForSpecials(((ToggleableButton)controlList.get(a)));
				((ToggleableButton)controlList.get(a)).setValue(person.options);
			}
		}
		person.changeSkin(textFields.get(0).getText());
		super.onGuiClosed();
	}
	
	private void checkForSpecials(ToggleableButton toggleableButton) {
		if(toggleableButton.objValue.equals("guard")){
			if(toggleableButton.value != person.options.guard){
				person.setGuardPositions();
			}
		}
		
	}
	
	
	
	

}
