package net.minecraft.src;

import org.lwjgl.opengl.GL11;

import net.minecraft.client.Minecraft;

public class GuiSoundPackageSlot extends GuiSlot{

	GuiScreen parent;
	
	public GuiSoundPackageSlot(Minecraft par1Minecraft, int par2, int par3, int par4, int par5, int par6, GuiScreen parent) {
		super(par1Minecraft, par2, par3, par4, par5, par6);
		this.parent = parent;
	}

	@Override
	protected int getSize() {
		return SoundPackage.allPackages.size();
	}

	@Override
	protected void elementClicked(int i, boolean flag) {
		SoundPackage.setSelected(i, true);
	}

	@Override
	protected boolean isSelected(int i) {
		return SoundPackage.currentSelected == i;
	}

	@Override
	protected void drawBackground() {
		parent.drawDefaultBackground();
	}
	
    protected int getContentHeight()
    {
        return getSize() * 36;
    }

    protected void drawSlot(int par1, int par2, int par3, int par4, Tessellator par5Tessellator)
    {
    	SoundPackage p = SoundPackage.allPackages.get(par1);
    	if(p != null){
    		p.bindIcon();
            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
            par5Tessellator.startDrawingQuads();
            par5Tessellator.setColorOpaque_I(0xffffff);
            par5Tessellator.addVertexWithUV(par2, par3 + par4, 0.0D, 0.0D, 1.0D);
            par5Tessellator.addVertexWithUV(par2 + 32, par3 + par4, 0.0D, 1.0D, 1.0D);
            par5Tessellator.addVertexWithUV(par2 + 32, par3, 0.0D, 1.0D, 0.0D);
            par5Tessellator.addVertexWithUV(par2, par3, 0.0D, 0.0D, 0.0D);
            par5Tessellator.draw();
            parent.drawString(parent.fontRenderer, p.packName, par2 + 32 + 2, par3 + 1, 0xffffff);
            parent.drawString(parent.fontRenderer, p.packText, par2 + 32 + 2, par3 + 12, 0x808080);
            parent.drawString(parent.fontRenderer, p.packAuthor, par2 + 32 + 2, par3 + 12 + 10, 0x808080);
    	}
    }

}
