package net.minecraft.src;

import java.awt.FontMetrics;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

public class GuiTransferPlayerItems extends GuiContainer{
	EntityMyPerson player;
	EntityPlayer thePlayer;
	boolean isGuiForDefault = false;
	public GuiTransferPlayerItems(EntityMyPerson otherPlayer, EntityPlayer mainPlayer, boolean b) {
		super(new ContainerTransferPlayerItems(mainPlayer, otherPlayer));
		player = otherPlayer;
		thePlayer = mainPlayer;
		xSize = 176;
		ySize = 212;
		isGuiForDefault = b;
	}
	
	

    @Override
	protected void actionPerformed(GuiButton gb) {
		if(gb.id==0){
			mc.thePlayer.addExperience(player.experienceTotal);
			player.experience = 0;
			player.experienceLevel = 0;
			player.experienceTotal = 0;
			player.experienceValue = 0;
		}else if(gb.id == 1){
			mc.displayGuiScreen(new GuiMorePeopleOptions(player, player.options, this));
		}else if(gb.id == 2){
			mc.displayGuiScreen(new GuiPlayerTeams(player, this));
		}else if(gb.id == 3){
			buildUp += .19f;
			if(buildUp >= 1.0f){
				player.doKill();
				mc.displayGuiScreen(null);
			}else{
				coloured.red = 1.0f;
				coloured.green = 1.0f-buildUp;
				coloured.blue = 1.0f-buildUp;
			}
		}else if(gb.id == 4){
			mc.displayGuiScreen(null);
			mod_MyPeople.instance.startMountingMode(mc);
		}
	}

    GuiTeamButton coloured;
    float buildUp = 0;
	@Override
	public void initGui() {
    	controlList.clear();
    	int bottom = height-20;
    	controlList.add(new GuiButton(0, 5, 50, 100, 20, "Transfer XP"));
		controlList.add(new GuiButton(1, 5, 75, 100, 20, "Options"));
		controlList.add(new GuiButton(2, 5, 100, 100, 20, "Teams"));
		controlList.add(new GuiButton(4, 5, 125, 100, 20, "Mount Mode"));
		
		controlList.add(coloured = new GuiTeamButton(3, 5, height - 35, 100, 20, "Kill.", 0xffffff, 0));
    	super.initGui();
	}



	protected void drawGuiContainerForegroundLayer()
    {
        fontRenderer.drawString("Tranfer Items", ((xSize/2)-(this.fontRenderer.getStringWidth("Tranfer Items")/2)), -8, 0xc0c0c0);
    }

    protected void drawGuiContainerBackgroundLayer(float f, int i, int j)
    {
        int k = mc.renderEngine.getTexture("/MyPeople/transferplayeritems.png");
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        mc.renderEngine.bindTexture(k);
        int l = guiLeft;
        int i1 = guiTop;
        drawTexturedModalRect(l, i1, 0, 0, xSize, ySize);
        displayDebuffEffects();
        drawFood();
        drawXP();

    }
    
    

	@Override
	protected void mouseClicked(int i, int j, int k) {
		super.mouseClicked(i, j, k);
	}

	private void drawXP() {
		GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture("/gui/icons.png"));
		GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
		int x = (width-182)/2;
		int y = height-10;
		float xpPercent = player.experience;
		drawTexturedModalRect(x, y, 0, 64, 182, 5);
		drawTexturedModalRect(x, y, 0, 69, (int)Math.round(182f*xpPercent), 5);
		String s = "" + player.experienceLevel;
		int k3 = (x+91)-((fontRenderer.getStringWidth(s)) / 2);
		mc.fontRenderer.drawString(s, k3, height-12, 0x80ff20);
	}

	private void drawFood() {
		
        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture("/gui/icons.png"));
		int x = 5;
		int y = (height-20)-200;
		int across = 10;
		int down = 1;
		this.drawRect(x-1, y-1, x+(across*9)+1, y+(down*9)+1, 0x50dddddd);
		double d = player.foodStats.getFoodLevel();
		int add = 0;
		if (player.isPotionActive(Potion.hunger))
        {
            add = 36;
        }
		double d1 = (d==0?0:d/2d);
		for(int a = 0; a < across; a++){
			for(int b = 0; b < down; b++){
				double level = 10-(b*5+a);
				int x1 = x + a*9;
				int y1 = y + b*9;
				byte type = 0;
				if(d1 > level-1 && d1 < level){
					type = 1;
				}else if(d1 >= level){
					type = 0;
				}else if(d1 < level){
					type = -1;
				}
				drawTexturedModalRect(x1, y1, 16, 27, 9, 9);
				if(type >= 0)drawTexturedModalRect(x1, y1, 52+(type*9)+add, 27, 9, 9);
			}
			player.foodStats.getFoodLevel();
		}
		
	}
	
    private void displayDebuffEffects()
    {
        int i = guiLeft + this.xSize+2;
        int j = guiTop;
        int k = mc.renderEngine.getTexture("/gui/inventory.png");
        Collection collection = player.getActivePotionEffects();

        if (collection.isEmpty())
        {
            return;
        }

        int l = 33;

        if (collection.size() > 5)
        {
            l = 132 / (collection.size() - 1);
        }

        for (Iterator iterator = player.getActivePotionEffects().iterator(); iterator.hasNext();)
        {
            PotionEffect potioneffect = (PotionEffect)iterator.next();
            Potion potion = Potion.potionTypes[potioneffect.getPotionID()];
            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
            mc.renderEngine.bindTexture(k);
            drawTexturedModalRect(i, j, 0, 166/**ABC*/, 140, 32);

            if (potion.hasStatusIcon())
            {
                int i1 = potion.getStatusIconIndex();
                drawTexturedModalRect(i + 6, j + 7, 0 + (i1 % 8) * 18, 166/**ABC*/ + 32 + (i1 / 8) * 18, 18, 18);
            }

            String s = StatCollector.translateToLocal(potion.getName());

            if (potioneffect.getAmplifier() == 1)
            {
                s = (new StringBuilder()).append(s).append(" II").toString();
            }
            else if (potioneffect.getAmplifier() == 2)
            {
                s = (new StringBuilder()).append(s).append(" III").toString();
            }
            else if (potioneffect.getAmplifier() == 3)
            {
                s = (new StringBuilder()).append(s).append(" IV").toString();
            }

            fontRenderer.drawStringWithShadow(s, i + 10 + 18, j + 6, 0xffffff);
            String s1 = Potion.getDurationString(potioneffect);
            fontRenderer.drawStringWithShadow(s1, i + 10 + 18, j + 6 + 10, 0x7f7f7f);
            j += l;
        }
    }




	public boolean doesGuiPauseGame() {
		return true;
	}
	
    
    //THis should stop TMI from being drawn... Hopefully!
    public void drawScreen(int par1, int par2, float par3)
    {
        drawDefaultBackground();
        int i = guiLeft;
        int j = guiTop;
        drawGuiContainerBackgroundLayer(par3, par1, par2);
        RenderHelper.enableGUIStandardItemLighting();
        GL11.glPushMatrix();
        GL11.glTranslatef(i, j, 0.0F);
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
        Slot slot = null;
        int k = 240;
        int i1 = 240;
        OpenGlHelper.setLightmapTextureCoords(OpenGlHelper.lightmapTexUnit, (float)k / 1.0F, (float)i1 / 1.0F);
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);

        for (int l = 0; l < inventorySlots.inventorySlots.size(); l++)
        {
            Slot slot1 = (Slot)inventorySlots.inventorySlots.get(l);
            drawSlotInventory(slot1);

            if (isMouseOverSlot(slot1, par1, par2))
            {
                slot = slot1;
                GL11.glDisable(GL11.GL_LIGHTING);
                GL11.glDisable(GL11.GL_DEPTH_TEST);
                int j1 = slot1.xDisplayPosition;
                int k1 = slot1.yDisplayPosition;
                drawGradientRect(j1, k1, j1 + 16, k1 + 16, 0x80ffffff, 0x80ffffff);
                GL11.glEnable(GL11.GL_LIGHTING);
                GL11.glEnable(GL11.GL_DEPTH_TEST);
            }
        }

        drawGuiContainerForegroundLayer();
        InventoryPlayer inventoryplayer = mc.thePlayer.inventory;

        if (inventoryplayer.getItemStack() != null)
        {
            GL11.glTranslatef(0.0F, 0.0F, 32F);
            zLevel = 200F;
            itemRenderer.zLevel = 200F;
            itemRenderer.renderItemIntoGUI(fontRenderer, mc.renderEngine, inventoryplayer.getItemStack(), par1 - i - 8, par2 - j - 8);
            itemRenderer.renderItemOverlayIntoGUI(fontRenderer, mc.renderEngine, inventoryplayer.getItemStack(), par1 - i - 8, par2 - j - 8);
            zLevel = 0.0F;
            itemRenderer.zLevel = 0.0F;
        }

        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
        RenderHelper.disableStandardItemLighting();
        GL11.glDisable(GL11.GL_LIGHTING);
        GL11.glDisable(GL11.GL_DEPTH_TEST);

        if (inventoryplayer.getItemStack() == null && slot != null && slot.getHasStack())
        {
            ItemStack itemstack = slot.getStack();
            List list = itemstack.getItemNameandInformation();

            if (list.size() > 0)
            {
                int l1 = 0;

                for (int i2 = 0; i2 < list.size(); i2++)
                {
                    int k2 = fontRenderer.getStringWidth((String)list.get(i2));

                    if (k2 > l1)
                    {
                        l1 = k2;
                    }
                }

                int j2 = (par1 - i) + 12;
                int l2 = par2 - j - 12;
                int i3 = l1;
                int j3 = 8;

                if (list.size() > 1)
                {
                    j3 += 2 + (list.size() - 1) * 10;
                }

                zLevel = 300F;
                itemRenderer.zLevel = 300F;
                int k3 = 0xf0100010;
                drawGradientRect(j2 - 3, l2 - 4, j2 + i3 + 3, l2 - 3, k3, k3);
                drawGradientRect(j2 - 3, l2 + j3 + 3, j2 + i3 + 3, l2 + j3 + 4, k3, k3);
                drawGradientRect(j2 - 3, l2 - 3, j2 + i3 + 3, l2 + j3 + 3, k3, k3);
                drawGradientRect(j2 - 4, l2 - 3, j2 - 3, l2 + j3 + 3, k3, k3);
                drawGradientRect(j2 + i3 + 3, l2 - 3, j2 + i3 + 4, l2 + j3 + 3, k3, k3);
                int l3 = 0x505000ff;
                int i4 = (l3 & 0xfefefe) >> 1 | l3 & 0xff000000;
                drawGradientRect(j2 - 3, (l2 - 3) + 1, (j2 - 3) + 1, (l2 + j3 + 3) - 1, l3, i4);
                drawGradientRect(j2 + i3 + 2, (l2 - 3) + 1, j2 + i3 + 3, (l2 + j3 + 3) - 1, l3, i4);
                drawGradientRect(j2 - 3, l2 - 3, j2 + i3 + 3, (l2 - 3) + 1, l3, l3);
                drawGradientRect(j2 - 3, l2 + j3 + 2, j2 + i3 + 3, l2 + j3 + 3, i4, i4);

                for (int j4 = 0; j4 < list.size(); j4++)
                {
                    String s = (String)list.get(j4);

                    if (j4 == 0)
                    {
                        s = (new StringBuilder()).append("\247").append(Integer.toHexString(itemstack.getRarity().nameColor)).append(s).toString();
                    }
                    else
                    {
                        s = (new StringBuilder()).append("\2477").append(s).toString();
                    }

                    fontRenderer.drawStringWithShadow(s, j2, l2, -1);

                    if (j4 == 0)
                    {
                        l2 += 2;
                    }

                    l2 += 10;
                }

                zLevel = 0.0F;
                itemRenderer.zLevel = 0.0F;
            }
        }

        GL11.glPopMatrix();
        for (int i2 = 0; i2 < controlList.size(); i2++)
        {
            GuiButton guibutton = (GuiButton)controlList.get(i2);
            guibutton.drawButton(mc, par1, par2);
        }
        GL11.glEnable(GL11.GL_LIGHTING);
        GL11.glEnable(GL11.GL_DEPTH_TEST);
    }

    
    private void drawSlotInventory(Slot par1Slot)
    {
        int i = par1Slot.xDisplayPosition;
        int j = par1Slot.yDisplayPosition;
        ItemStack itemstack = par1Slot.getStack();
        boolean flag = false;
        int k = i;
        int i1 = j;
        zLevel = 100F;
        itemRenderer.zLevel = 100F;

        if (itemstack == null)
        {
            int j1 = par1Slot.getBackgroundIconIndex();

            if (j1 >= 0)
            {
                GL11.glDisable(GL11.GL_LIGHTING);
                mc.renderEngine.bindTexture(mc.renderEngine.getTexture("/gui/items.png"));
                drawTexturedModalRect(k, i1, (j1 % 16) * 16, (j1 / 16) * 16, 16, 16);
                GL11.glEnable(GL11.GL_LIGHTING);
                flag = true;
            }
        }

        if (!flag)
        {
            itemRenderer.renderItemIntoGUI(fontRenderer, mc.renderEngine, itemstack, k, i1);
            itemRenderer.renderItemOverlayIntoGUI(fontRenderer, mc.renderEngine, itemstack, k, i1);
        }

        itemRenderer.zLevel = 0.0F;
        zLevel = 0.0F;

        if (this == null)
        {
            zLevel = 100F;
            itemRenderer.zLevel = 100F;

            if (itemstack == null)
            {
                int l = par1Slot.getBackgroundIconIndex();

                if (l >= 0)
                {
                    GL11.glDisable(GL11.GL_LIGHTING);
                    mc.renderEngine.bindTexture(mc.renderEngine.getTexture("/gui/items.png"));
                    drawTexturedModalRect(i, j, (l % 16) * 16, (l / 16) * 16, 16, 16);
                    GL11.glEnable(GL11.GL_LIGHTING);
                    flag = true;
                }
            }

            if (!flag)
            {
                itemRenderer.renderItemIntoGUI(fontRenderer, mc.renderEngine, itemstack, i, j);
                itemRenderer.renderItemOverlayIntoGUI(fontRenderer, mc.renderEngine, itemstack, i, j);
            }

            itemRenderer.zLevel = 0.0F;
            zLevel = 0.0F;
        }
    }
    
    private boolean isMouseOverSlot(Slot par1Slot, int par2, int par3)
    {
        int i = guiLeft;
        int j = guiTop;
        par2 -= i;
        par3 -= j;
        return par2 >= par1Slot.xDisplayPosition - 1 && par2 < par1Slot.xDisplayPosition + 16 + 1 && par3 >= par1Slot.yDisplayPosition - 1 && par3 < par1Slot.yDisplayPosition + 16 + 1;
    }



	@Override
	public void onGuiClosed() {
		super.onGuiClosed();
		if(isGuiForDefault){
			mod_MyPeople.instance.save(mc.theWorld);
		}
	}
    
    
    

}
