package net.minecraft.src;

import java.util.ArrayList;
import java.util.HashMap;

import net.minecraft.src.PersonOptions.Options;

public class GuiUniversalPlayerOptions extends GuiScreen{
	int position = 0;
	int max = 18;
	ArrayList<GuiTextField> textFields = new ArrayList<GuiTextField>();
	ArrayList<Gui> all = new ArrayList<Gui>();
	GuiScreen prev;
	int maxDown = 0, maxAcross = 0;
	public GuiUniversalPlayerOptions(GuiScreen previous) {
		prev = previous;
	}
	
	
	
	



	@Override
	public void initGui() {
		maxDown = height/25;
		maxAcross = width/140;
		max = maxDown*maxAcross;
		controlList.clear();
		textFields.clear();
		addTextField("", 0);
		Options[] ops = PersonOptions.Options.values();
		for(int a = 0; a < ops.length; a++){
			addToggleButton(ops[a].displayName, false, ops[a].valueName);
		}
		controlList.add(new GuiButton(98, position/maxDown*140, ((position%maxDown)*25), 135, 20, "Set All"));
		controlList.add(new GuiButton(99, (((max)-1) / maxDown)*140, (((max)-1) % maxDown)*25, 136, 20, "Done"));
	}

	









	@Override
	protected void actionPerformed(GuiButton guiButton) {
		if(guiButton.id == 99){
			mc.displayGuiScreen(prev);
		}else if(guiButton.id == 98){
			for(int b = 0; b < controlList.size(); b++){
				Gui gui = (Gui)controlList.get(b);
				if(gui instanceof ToggleableButton){
					for(int a = 0; a < mc.theWorld.playerEntities.size(); a++){
						if(mc.theWorld.playerEntities.get(a) instanceof EntityMyPerson){
							PersonOptions o = ((EntityMyPerson)mc.theWorld.playerEntities.get(a)).options;
							((ToggleableButton)gui).setValue(o);
						}
					}
				}else if(gui instanceof GuiPeopleOptionTextField){
					GuiPeopleOptionTextField g = (GuiPeopleOptionTextField)gui;
					for(int a = 0; a < mc.theWorld.playerEntities.size(); a++){
						if(mc.theWorld.playerEntities.get(a) instanceof EntityMyPerson){
							g.handleSet(((EntityMyPerson)mc.theWorld.playerEntities.get(a)));
						}
					}
				}
			}
			
			
		}else if(guiButton.id >= 100){
			Gui gui = objects.get(guiButton);
			if(gui == null){
				return;
			}
			if(gui instanceof ToggleableButton){
				for(int a = 0; a < mc.theWorld.playerEntities.size(); a++){
					if(mc.theWorld.playerEntities.get(a) instanceof EntityMyPerson){
						PersonOptions o = ((EntityMyPerson)mc.theWorld.playerEntities.get(a)).options;
						((ToggleableButton)gui).setValue(o);
					}
				}
			}else if(gui instanceof GuiPeopleOptionTextField){
				GuiPeopleOptionTextField g = (GuiPeopleOptionTextField)gui;
				for(int a = 0; a < mc.theWorld.playerEntities.size(); a++){
					if(mc.theWorld.playerEntities.get(a) instanceof EntityMyPerson){
						g.handleSet(((EntityMyPerson)mc.theWorld.playerEntities.get(a)));
					}
				}
			}
		}
	}

	HashMap<GuiButton, Gui> objects = new HashMap<GuiButton, Gui>();






	public void addTextField(String value, int type){
		if(position < max){
			int posX = position / maxDown;
			int posY = position % maxDown;
			posX *= 140;
			posY *= 25;
			GuiButton key;
			GuiPeopleOptionTextField value2;
			textFields.add(value2 = new GuiPeopleOptionTextField(this, mc.fontRenderer, posX+2, posY+1, 96, 18, value, type));
			controlList.add(key = new GuiButton(position+100, posX + 105, posY, 30, 20, "Set"));
			objects.put(key, value2);
			position++;
		}
	}
	
	public void addToggleButton(String text, boolean value, String  objValue){
		if(position < max){
			int posX = position / maxDown;
			int posY = position % maxDown;
			posX *= 140;
			posY *= 25;
			GuiButton key;
			ToggleableButton value2;
			controlList.add(value2 = new ToggleableButton(position, posX, posY, 100, 20, text, value, objValue));
			controlList.add(key = new GuiButton(position+100, posX + 105, posY, 30, 20, "Set"));
			objects.put(key, value2);
			position++;
		}
	}
	
	
	
	@Override
	public void drawScreen(int par1, int par2, float par3) {
		drawDefaultBackground();
		for(int a = 0; a < controlList.size(); a++){
			((GuiButton)controlList.get(a)).drawButton(mc, par1, par2);
		}
		for(int a = 0; a < textFields.size(); a++){
			((GuiTextField)textFields.get(a)).drawTextBox();
		}
	}
	
	
	@Override
	public void updateScreen() {
		for(int a = 0; a < textFields.size(); a++){
			textFields.get(a).updateCursorCounter();
		}
		super.updateScreen();
	}
	@Override
	protected void keyTyped(char par1, int par2) {
		for(int a = 0; a < textFields.size(); a++){
			textFields.get(a).func_50037_a(par1, par2);
		}
		super.keyTyped(par1, par2);
	}
	@Override
	protected void mouseClicked(int par1, int par2, int par3) {
		for(int a = 0; a < textFields.size(); a++){
			textFields.get(a).mouseClicked(par1, par2, par3);
		}
		super.mouseClicked(par1, par2, par3);
	}

}
