package net.minecraft.src;

public class ItemNeedle extends ItemSword{
	boolean blood = false;
	public ItemNeedle(int i, boolean blood){
		super(i, EnumToolMaterial.STONE);
		setMaxDamage(0);
		this.blood = blood;
	}
	
	@Override
	public ItemStack onItemRightClick(ItemStack itemstack, World world, EntityPlayer entityplayer) {
		if(itemstack.getItemDamage() != 0 || itemstack.itemID != mod_MyPeople.needleBlood.shiftedIndex){
			itemstack = new ItemStack(mod_MyPeople.needleBlood, 1, 0);
			if(!entityplayer.capabilities.disableDamage){
				entityplayer.health-=2;
				entityplayer.addPotionEffect(new PotionEffect(9, 1200, 0));
				entityplayer.addPotionEffect(new PotionEffect(17, 1200, 0));
				entityplayer.addPotionEffect(new PotionEffect(18, 1200, 0));
			}
			entityplayer.triggerAchievement(mod_MyPeople.instance.WTF);
			world.playSoundAtEntity(entityplayer, "random.drink", 0.5F, world.rand.nextFloat() * 0.1F + 0.9F);
		}
		return itemstack;
	}
	
	
	
    @Override
	public boolean onItemUse(ItemStack par1ItemStack,
			EntityPlayer par2EntityPlayer, World par3World, int i, int j,
			int k, int l) {
		return true;
	}

	public int getColorFromDamage(int par1, int par2)
    {
        EntityEggInfo entityegginfo = (EntityEggInfo)EntityList.entityEggs.get(Integer.valueOf(par1));

        if (entityegginfo != null)
        {
            if (par2 == 0)
            {
                return entityegginfo.primaryColor;
            }
            else
            {
                return entityegginfo.secondaryColor;
            }
        }
        else
        {
            return 0xffffff;
        }
    }

	@Override
	public int getDamageVsEntity(Entity entity) {
		return 4;
	}

	@Override
	public boolean hitEntity(ItemStack itemstack, EntityLiving entityliving, EntityLiving entityliving1) {
		int id = EntityList.getEntityID(entityliving);
		if(id == mod_MyPeople.id){
			id = 0;
		}
		if(id > 0 && EntityList.entityEggs.containsKey(id) && itemstack.getItemDamage()!= id){
			itemstack.itemID = mod_MyPeople.needleBlood.shiftedIndex;
			itemstack.setItemDamage(id);
			entityliving.health-=2;
			entityliving.addPotionEffect(new PotionEffect(9, 1200, 0));
			entityliving.addPotionEffect(new PotionEffect(17, 1200, 0));
			entityliving.addPotionEffect(new PotionEffect(18, 1200, 0));
			entityliving.worldObj.playSoundAtEntity(entityliving, "random.drink", 0.5F, entityliving.worldObj.rand.nextFloat() * 0.1F + 0.9F);
			
			
			return true;
		}
		return false;
	}

}
