package net.minecraft.src;

import org.lwjgl.opengl.GL11;

public class MyRenderHelper {
	//south5 north 4 west3 east 2 top 1 bottom 0
	
	public void fix(){
		GL11.glTranslated(-RenderManager.renderPosX, -RenderManager.renderPosY, -RenderManager.renderPosZ);
	}
	
	public void renderBlock(Block b, int meta, double x, double y, double z, Render render, boolean fix, boolean cull){
		GL11.glPushMatrix();
		if(fix){
			fix();
		}
		boolean bool = false;
		if(cull){
			bool = GL11.glIsEnabled(GL11.GL_CULL_FACE);
			GL11.glDisable(GL11.GL_CULL_FACE);
		}
		GL11.glTranslated(x, y, z);
		render.loadTexture("/terrain.png");
		GL11.glDisable(GL11.GL_LIGHTING);
		GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
		renderTopFace(b, meta);
		renderBottomFace(b, meta);
		renderNorthFace(b, meta);
		renderSouthFace(b, meta);
		renderEastFace(b, meta);
		renderWestFace(b, meta);
		if(cull && bool){
			GL11.glEnable(GL11.GL_CULL_FACE);
		}
		GL11.glEnable(GL11.GL_LIGHTING);
		GL11.glPopMatrix();
	}
	
	public void renderBlock(Block b, int meta, double posX, double posY, double posZ){
		GL11.glPushMatrix();
		GL11.glTranslated(posX, posY, posZ);
		renderTopFace(b, meta);
		renderBottomFace(b, meta);
		renderNorthFace(b, meta);
		renderSouthFace(b, meta);
		renderEastFace(b, meta);
		renderWestFace(b, meta);
		GL11.glPopMatrix();
	}
	float f = .0625f;
	public void renderBottomFace(Block b, int meta){
		int i = b.getBlockTextureFromSideAndMetadata(0, meta);
		float x = (((i%16)*16)/256f);
		float y = (((i/16)*16)/256f);		
		GL11.glBegin(GL11.GL_QUADS);
		addVertexWithUV(0, 0, 0, x+f, y);
		addVertexWithUV(1, 0, 0, x, y);
		addVertexWithUV(1, 0, 1, x, y+f);
		addVertexWithUV(0, 0, 1, x+f, y+f);
		GL11.glEnd();
	}
	
	public void renderTopFace(Block b, int meta){
		int i = b.getBlockTextureFromSideAndMetadata(1, meta);
		float x = (((i%16)*16)/256f);
		float y = (((i/16)*16)/256f);
		GL11.glBegin(GL11.GL_QUADS);
		addVertexWithUV(0, 1, 1, x+f, y);
		addVertexWithUV(1, 1, 1, x, y);
		addVertexWithUV(1, 1, 0, x, y+f);
		addVertexWithUV(0, 1, 0, x+f, y+f);
		GL11.glEnd();
	}
	
	public void renderEastFace(Block b, int meta){
		int i = b.getBlockTextureFromSideAndMetadata(2, meta);
		float x = (((i%16)*16)/256f);
		float y = (((i/16)*16)/256f);
		GL11.glBegin(GL11.GL_QUADS);
		addVertexWithUV(0, 1, 1, x+f, y);
		addVertexWithUV(0, 1, 0, x, y);
		addVertexWithUV(0, 0, 0, x, y+f);
		addVertexWithUV(0, 0, 1, x+f, y+f);
		GL11.glEnd();
	}
	
	public void renderWestFace(Block b, int meta){
		int i = b.getBlockTextureFromSideAndMetadata(3, meta);
		float x = (((i%16)*16)/256f);
		float y = (((i/16)*16)/256f);
		GL11.glBegin(GL11.GL_QUADS);
		addVertexWithUV(1, 1, 0, x+f, y);
		addVertexWithUV(1, 1, 1, x, y);
		addVertexWithUV(1, 0, 1, x, y+f);
		addVertexWithUV(1, 0, 0, x+f, y+f);
		GL11.glEnd();
	}
	
	public void renderNorthFace(Block b, int meta){
		int i = b.getBlockTextureFromSideAndMetadata(4, meta);
		float x = (((i%16)*16)/256f);
		float y = (((i/16)*16)/256f);
		GL11.glBegin(GL11.GL_QUADS);
		addVertexWithUV(0, 1, 0, x+f, y);
		addVertexWithUV(1, 1, 0, x, y);
		addVertexWithUV(1, 0, 0, x, y+f);
		addVertexWithUV(0, 0, 0, x+f, y+f);
		GL11.glEnd();
	}
	
	public void renderSouthFace(Block b, int meta){
		int i = b.getBlockTextureFromSideAndMetadata(5, meta);
		float x = (((i%16)*16)/256f);
		float y = (((i/16)*16)/256f);
		GL11.glBegin(GL11.GL_QUADS);
		addVertexWithUV(1, 1, 1, x+f, y);
		addVertexWithUV(0, 1, 1, x, y);
		addVertexWithUV(0, 0, 1, x, y+f);
		addVertexWithUV(1, 0, 1, x+f, y+f);
		GL11.glEnd();
	}
	
	public void addVertexWithUV(double d1, double d2, double d3, float f1, float f2){
		GL11.glTexCoord2f(f1, f2);
		GL11.glVertex3d(d1, d2, d3);
	}
	
	static MyRenderHelper instance;
	
	static{
		instance = new MyRenderHelper();
	}

}
