package net.minecraft.src;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.HashMap;

public class PersonOptions{

	public enum Options {
		sprint("sprint", "Sprint"), follow("follow", "Follow"), fight("fight", "Fight"), huntAnimal(
				"huntAnimal", "Hunt Animals"), huntMob("huntMob", "Hunt Mobs"), lumber(
				"lumber", "Lumber"), mine("mine", "Mine"), pickUp("pickUp",
				"Pick Up Items"), retaliate("retaliate", "Retaliate"), boat(
				"boat", "Use Boats"), female("female", "Female"), farm("farm", "Farm"),
				guard("guard", "Guard Position")
				, wander("wander", "Wander"), jump("jump",
				"Jump On Attack"), curious("curious", "Curious"), breakExtraBlocks(
				"breakExtraBlocks", "Break Roughly"), travel("travel", "Travel"), 
				stats("stats", "Render Stats"), talk("talk", "Talk"), chat("chat", "Chat");

		String valueName, displayName;

		Options(String valueName, String displayName) {
			this.valueName = valueName;
			this.displayName = displayName;
		}
	}
	EntityMyPerson person;
	public PersonOptions(EntityMyPerson person){
		this.person = person;
	}
	boolean fight = false;
	boolean sprint = false;
	boolean follow = false;
	boolean mine = false;
	boolean lumber = false;
	boolean pickUp = false;
	boolean farm = false;
	boolean boat = false;
	boolean retaliate = false;
	boolean huntMob = false;
	boolean huntAnimal = false;
	boolean guard = false;
	boolean wander = false;
	boolean jump = false;
	boolean curious = false;
	boolean breakExtraBlocks = false;
	boolean travel = true;
	boolean stats = true;
	boolean female = false;
	boolean chat = false;
	boolean talk = false;
	
	boolean chests = false;
	boolean enchant = false;

	public void write(NBTTagCompound nbt) {
		NBTTagCompound c = new NBTTagCompound();
		for (int a = 0; a < allFields.size(); a++) {
			Field f = allFields.get(a);
			try {
				c.setBoolean(f.getName(), f.getBoolean(this));
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		nbt.setCompoundTag("optionsData", c);
	}

	public void read(NBTTagCompound nbt) {
		NBTTagCompound c = nbt.getCompoundTag("optionsData");
		for (int a = 0; a < allFields.size(); a++) {
			Field f = allFields.get(a);
			try {
				f.setBoolean(this, c.getBoolean(f.getName()));
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	
	private boolean getValue(String fieldName){
		try {
			Field f = this.getClass().getDeclaredField(fieldName);
			if (f != null) {
				f.setAccessible(true);
				Object o = f.get(this);
				if (o != null
						&& (boolean.class.isAssignableFrom(o.getClass()) || java.lang.Boolean.class
								.isAssignableFrom(o.getClass()))) {
					return (Boolean) o;
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}

	public boolean getValue(Options option) {
		return getValue(option.valueName);
	}

	public void setValue(String s, boolean value) {
		try {
			Field f = values.get(s);
			if (f != null) {
				checkForSpecials(s, value);
				f.set(this, value);

			}
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public static void setupMap() {
		Field[] fields = PersonOptions.class.getDeclaredFields();
		values = new HashMap<String, Field>();
		allFields = new ArrayList<Field>();
		for (int a = 0; a < fields.length; a++) {
			Field f = fields[a];
			if (f != null
					&& !java.lang.reflect.Modifier.isStatic(f.getModifiers())
					&& isBoolean(f)) {
				f.setAccessible(true);
				values.put(f.getName(), f);
				allFields.add(f);
			}
		}
	}

	public static boolean isBoolean(Field f) {
		return boolean.class.isAssignableFrom(f.getType())
				|| java.lang.Boolean.class.isAssignableFrom(f.getType());
	}
	
	public void checkForSpecials(String fieldName, boolean valueToSet){
		boolean value = getValue(fieldName);
		if(fieldName.equals(Options.guard.valueName) && valueToSet == true && value == false){
			person.setGuardPositions();
		}
	}
	
	public void copyInto(PersonOptions o){
		try{
			for(int a = 0; a < allFields.size(); a++){
				Field f = allFields.get(a);
				f.setAccessible(true);
				boolean value = (Boolean)f.getBoolean(this);
				f.setBoolean(o, value);
				o.checkForSpecials(f.getName(), value);
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	

	static {
		setupMap();
	}
	static ArrayList<Field> allFields;
	static HashMap<String, Field> values;

}
